"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.contramap = exports.and = exports.always = exports.URI = exports.Invariant = exports.Contravariant = void 0;
Object.defineProperty(exports, "deriveEq", {
  enumerable: true,
  get: function () {
    return _eqSchemable.deriveEq;
  }
});
exports.or = exports.imap = exports.fromEquals = exports.eqStrict = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var I = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/eq"));

var _eqSchemable = /*#__PURE__*/require("schemata-ts/derivations/eq-schemable");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// ------------------
// constructors
// ------------------

/**
 * @since 2.0.0
 * @category Constructors
 */
const fromEquals = I.fromEquals; // ------------------
// combinators
// ------------------

exports.fromEquals = fromEquals;
// ------------------
// instances
// ------------------

/**
 * @since 2.0.0
 * @category URI
 */
const URI = 'schemata-ts/Eq';
/**
 * @since 2.0.0
 * @category Instance Methods
 */

exports.URI = URI;
const imap = I.imap;
/**
 * @since 2.0.0
 * @category Instances
 */
// istanbul ignore next

exports.imap = imap;
const Invariant = {
  URI,
  imap: (fa, f, g) => imap(f, g)(fa)
};
/**
 * @since 2.0.0
 * @category Instance Methods
 */

exports.Invariant = Invariant;
const contramap = I.contramap;
/**
 * @since 2.0.0
 * @category Instances
 */
// istanbul ignore next

exports.contramap = contramap;
const Contravariant = {
  URI,
  contramap: (fa, f) => contramap(f)(fa)
};
/**
 * @since 2.0.0
 * @category Combinators
 */

exports.Contravariant = Contravariant;

const and = that => self => ({
  equals: (x, y) => self.equals(x, y) && that.equals(x, y)
});
/**
 * @since 2.0.0
 * @category Instances
 */


exports.and = and;
const always = {
  equals: _function.constTrue
};
/**
 * @since 2.0.0
 * @category Combinators
 */

exports.always = always;

const or = that => self => ({
  equals: (x, y) => self.equals(x, y) || that.equals(x, y)
});
/**
 * @since 2.0.0
 * @category Instances
 */


exports.or = or;
const eqStrict = I.eqStrict;
exports.eqStrict = eqStrict;
//# sourceMappingURL=Eq.js.map