"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.URI = void 0;
Object.defineProperty(exports, "deriveGuard", {
  enumerable: true,
  get: function () {
    return _guardSchemable.deriveGuard;
  }
});
exports.fromPredicate = exports.deriveInputGuard = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _transcoderSchemable = /*#__PURE__*/require("schemata-ts/derivations/transcoder-schemable");

var I = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/guard"));

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * `Guard` is a data-type that narrows an unknown value to a specific type using
 * Typescript type guards
 *
 * @since 2.0.0
 */
// ------------------
// constructors
// ------------------

/**
 * Constructs a guard from predicate function
 *
 * @since 2.0.0
 * @category Constructors
 */
const fromPredicate = I.fromPredicate; // ------------------
// combinators
// ------------------

exports.fromPredicate = fromPredicate;

/**
 * Interprets a schema as a guard for the `Input` type
 *
 * @since 2.1.0
 * @category Interpreters
 */
const deriveInputGuard = schema => {
  const transcoder = (0, _transcoderSchemable.deriveTranscoder)(schema);
  return {
    is: u => E.isRight(transcoder.decode(u))
  };
}; // ------------------
// instances
// ------------------

/**
 * @since 2.0.0
 * @category URI
 */


exports.deriveInputGuard = deriveInputGuard;
const URI = 'schemata-ts/Guard';
exports.URI = URI;
//# sourceMappingURL=Guard.js.map