import { constTrue } from "fp-ts/es6/function.js";
import * as I from 'schemata-ts/internal/eq'; // ------------------
// constructors
// ------------------

/**
 * @since 2.0.0
 * @category Constructors
 */

export const fromEquals = I.fromEquals; // ------------------
// combinators
// ------------------

export {
/**
 * Interprets a schema as an `Eq` instance.
 *
 * @since 2.0.0
 * @category Interpreters
 */
deriveEq } from 'schemata-ts/derivations/eq-schemable'; // ------------------
// instances
// ------------------

/**
 * @since 2.0.0
 * @category URI
 */

export const URI = 'schemata-ts/Eq';
/**
 * @since 2.0.0
 * @category Instance Methods
 */

export const imap = I.imap;
/**
 * @since 2.0.0
 * @category Instances
 */
// istanbul ignore next

export const Invariant = {
  URI,
  imap: (fa, f, g) => imap(f, g)(fa)
};
/**
 * @since 2.0.0
 * @category Instance Methods
 */

export const contramap = I.contramap;
/**
 * @since 2.0.0
 * @category Instances
 */
// istanbul ignore next

export const Contravariant = {
  URI,
  contramap: (fa, f) => contramap(f)(fa)
};
/**
 * @since 2.0.0
 * @category Combinators
 */

export const and = that => self => ({
  equals: (x, y) => self.equals(x, y) && that.equals(x, y)
});
/**
 * @since 2.0.0
 * @category Instances
 */

export const always = {
  equals: constTrue
};
/**
 * @since 2.0.0
 * @category Combinators
 */

export const or = that => self => ({
  equals: (x, y) => self.equals(x, y) || that.equals(x, y)
});
/**
 * @since 2.0.0
 * @category Instances
 */

export const eqStrict = I.eqStrict;
//# sourceMappingURL=Eq.mjs.map