import { interpret } from 'schemata-ts/internal/schema';
import * as annotate from 'schemata-ts/schemables/annotate/instances/json-schema';
import * as array from 'schemata-ts/schemables/array/instances/json-schema';
import * as checkDigit from 'schemata-ts/schemables/check-digit/instances/json-schema';
import * as clone from 'schemata-ts/schemables/clone/instances/json-schema';
import * as date from 'schemata-ts/schemables/date/instances/json-schema';
import * as guardedUnion from 'schemata-ts/schemables/guarded-union/instances/json-schema';
import * as invariant from 'schemata-ts/schemables/invariant/instances/json-schema';
import * as lazy from 'schemata-ts/schemables/lazy/instances/json-schema';
import * as map from 'schemata-ts/schemables/map/instances/json-schema';
import * as optional from 'schemata-ts/schemables/optional/instances/json-schema';
import * as parser from 'schemata-ts/schemables/parser/instances/json-schema';
import * as pattern from 'schemata-ts/schemables/pattern/instances/json-schema';
import * as primitives from 'schemata-ts/schemables/primitives/instances/json-schema';
import * as refine from 'schemata-ts/schemables/refine/instances/json-schema';
import * as struct from 'schemata-ts/schemables/struct/instances/json-schema';
/**
 * @since 2.0.0
 * @category Instances
 */

const JsonSchemaSchemable = { ...annotate.AnnotateJsonSchema,
  ...array.ArrayJsonSchema,
  ...checkDigit.CheckDigitJsonSchema,
  ...clone.CloneJsonSchema,
  ...date.DateJsonSchema,
  ...guardedUnion.GuardedUnionJsonSchema,
  ...invariant.InvariantJsonSchema,
  ...lazy.LazyJsonSchema,
  ...map.MapJsonSchema,
  ...optional.OptionalJsonSchema,
  ...parser.ParserJsonSchema,
  ...pattern.PatternJsonSchema,
  ...primitives.PrimitivesJsonSchema,
  ...refine.RefineJsonSchema,
  ...struct.StructJsonSchema
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

export const deriveJsonSchema = /*#__PURE__*/interpret(JsonSchemaSchemable);
//# sourceMappingURL=json-schema-schemable.mjs.map