import { flow } from "fp-ts/es6/function.js";
import { MonoidSum } from "fp-ts/es6/number.js";
import * as RA from "fp-ts/es6/ReadonlyArray.js";
import * as Str from "fp-ts/es6/string.js";
/**
 * This calculates the Luhn checksum for a given string of digits.
 *
 * @internal
 */

export const luhn = /*#__PURE__*/flow( /*#__PURE__*/Str.split(''), RA.reverse, /*#__PURE__*/RA.map(d => parseInt(d)), /*#__PURE__*/RA.foldMapWithIndex(MonoidSum)((i, d) => i % 2 === 1 ? // numbers of odd rank stay the same
d : // numbers of even rank get doubled, then their digits are summed
d * 2 >= 10 ? 1 + (d * 2 - 10) : d * 2), sum => (10 - sum % 10) % 10);
//# sourceMappingURL=algorithms.mjs.map