/**
 * A schemable for determining information entropy of a schema.
 *
 * @since 2.0.0
 */
import { make } from "fp-ts/es6/Const.js";
/** @internal */

export const makeInformation = e => make(Math.min(e, Number.MAX_VALUE));
/** @internal */

export const informationFromSampleSize = sampleSize => sampleSize <= 0 ? makeInformation(0) : makeInformation(Math.log2(sampleSize));
//# sourceMappingURL=information.mjs.map