import { first, last } from "fp-ts/es6/Semigroup.js";
import { memoize } from 'schemata-ts/internal/schema'; // istanbul ignore next

/** @internal */

export const identity = choice => constSemigroup((concrete = 'last') => {
  if (concrete === 'last') {
    return last();
  }

  if (concrete === 'first') {
    return first();
  }

  const _ = concrete[choice];

  if (typeof _ !== 'string' && _ !== undefined) {
    return _;
  }

  if (_ === 'first') {
    return first();
  }

  if (_ === 'last') {
    return last();
  }

  return concrete['fallback'] === 'last' ? last() : first();
});
/** @internal */

export const constSemigroup = make => ({
  semigroup: memoize(make)
});
/** @internal */

export const makeMergeSemigroup = make => ({
  semigroup: memoize(concrete => ({
    concat: make(concrete)
  }))
});
//# sourceMappingURL=merge-semigroup.mjs.map