/**
 * A meta definition for a struct for use with `StructM` schema
 *
 * @since 1.3.0
 */
import { unsafeCoerce } from "fp-ts/es6/function.js";
import * as O from "fp-ts/es6/Option.js";
import { hasOwn } from 'schemata-ts/internal/util';
const ImplicitOptionalFlag = /*#__PURE__*/Symbol.for('schemata-ts/struct/ImplicitOptionalFlag');
const implicitOptional = {
  [ImplicitOptionalFlag]: ImplicitOptionalFlag
};
/** @internal */

export const makeImplicitOptional = (val, clone) => Object.assign(clone(val), implicitOptional);
/** @internal */

export const makeImplicitOptionalType = unsafeCoerce;
/** @internal */

export const hasImplicitOptional = u => hasOwn(u, ImplicitOptionalFlag);
const KeyRemap = /*#__PURE__*/Symbol.for('schemata-ts/struct/KeyRemap');
/** @internal */

export const remapKey = (val, clone, key) => Object.assign(clone(val), {
  [KeyRemap]: key
});
/** @internal */

export const getKeyRemap = val => hasOwn(val, KeyRemap) ? O.some(val[KeyRemap]) : O.none;
//# sourceMappingURL=struct.mjs.map