import * as Ap from "fp-ts/es6/Apply.js";
import { flow } from "fp-ts/es6/function.js";
import * as T from "fp-ts/es6/Task.js";
import * as TE from "fp-ts/es6/TaskEither.js";
import * as TCE from 'schemata-ts/TranscodeError';
/** @internal */

export const success = TE.right;
/** @internal */

export const failure = TE.throwError;
/** @internal */

export const applicativeValidationPar = /*#__PURE__*/TE.getApplicativeTaskValidation(T.ApplicativePar, TCE.Semigroup);
/** @internal */

export const apSecond = /*#__PURE__*/Ap.apSecond(applicativeValidationPar);
/** @internal */

export const apS = /*#__PURE__*/Ap.apS(applicativeValidationPar);
/** @internal */

export const fromTranscoder = tc => ({
  decode: flow(tc.decode, TE.fromEither),
  encode: flow(tc.encode, TE.fromEither)
});
/** @internal */

export const imap = (f, g) => fa => ({
  decode: u => TE.Functor.map(fa.decode(u), f),
  encode: out => fa.encode(g(out))
});
//# sourceMappingURL=transcoder-par.mjs.map