import * as Ap from "fp-ts/es6/Apply.js";
import * as E from "fp-ts/es6/Either.js";
import { flow } from "fp-ts/es6/function.js";
import * as TE from 'schemata-ts/TranscodeError';
/** @internal */

export const success = E.right;
/** @internal */

export const failure = E.throwError;
/** @internal */

export const transcodeErrors = (...errors) => new TE.TranscodeErrors(errors);
/** @internal */

export const typeMismatch = (...args) => new TE.TypeMismatch(...args);
/** @internal */

export const unexpectedValue = (...args) => new TE.UnexpectedValue(...args);
/** @internal */

export const serializationError = (...args) => new TE.SerializationError(...args);
/** @internal */

export const errorAtIndex = (...args) => new TE.ErrorAtIndex(...args);
/** @internal */

export const errorAtKey = (...args) => new TE.ErrorAtKey(...args);
/** @internal */

export const errorAtUnionMember = (...args) => new TE.ErrorAtUnionMember(...args);
/** @internal */

export const applicativeValidation = /*#__PURE__*/E.getApplicativeValidation(TE.Semigroup);
/** @internal */

export const apSecond = /*#__PURE__*/Ap.apSecond(applicativeValidation);
/** @internal */

export const apS = /*#__PURE__*/Ap.apS(applicativeValidation);
/** @internal */

export const fromGuard = (encode, onError) => guard => ({
  decode: E.fromPredicate(guard.is, onError),
  encode: flow(encode, E.right)
});
/** @internal */

export const imap = (f, g) => fa => ({
  decode: u => E.Functor.map(fa.decode(u), f),
  encode: out => fa.encode(g(out))
});
//# sourceMappingURL=transcoder.mjs.map