import { identity, pipe } from "fp-ts/es6/function.js";
import * as JS from 'schemata-ts/internal/json-schema';
export const AnnotateJsonSchema = {
  annotate: params => inner => {
    const {
      title,
      description,
      references,
      deprecated,
      readOnly
    } = params;
    const hasChanged = title !== undefined || description !== undefined || deprecated !== undefined || readOnly !== undefined;
    return pipe(inner, hasChanged ? JS.addDescription({ ...(title === undefined ? {} : {
        title
      }),
      ...(description === undefined ? {} : {
        description
      }),
      ...(deprecated === undefined ? {} : {
        deprecated
      }),
      ...(readOnly === undefined ? {} : {
        readOnly
      })
    }) : identity, references !== undefined ? JS.addReferences({
      $defs: references
    }) : identity);
  }
};
//# sourceMappingURL=json-schema.mjs.map