import * as RA from "fp-ts/es6/ReadonlyArray.js";
import * as Arb from 'schemata-ts/internal/arbitrary';
export const ArrayArbitrary = {
  array: params => {
    const {
      minLength = 0,
      maxLength = 2 ** 32 - 2
    } = params;
    return item => Arb.makeArbitrary(fc => fc.array(item.arbitrary(fc), {
      minLength: Math.floor(Math.max(minLength, 0)),
      maxLength: Math.floor(Math.min(maxLength, 2 ** 32 - 2))
    }));
  },
  tuple: (_, ...components) => Arb.makeArbitrary(fc => {
    if (components.length === 0) {
      return fc.constant(RA.zero());
    }

    return fc.tuple(...components.map(arb => arb.arbitrary(fc)));
  })
};
//# sourceMappingURL=arbitrary.mjs.map