import { pipe } from "fp-ts/es6/function.js";
import { concatAll } from "fp-ts/es6/Monoid.js";
import * as N from "fp-ts/es6/number.js";
import * as Inf from 'schemata-ts/internal/information';
export const ArrayInformation = {
  array: params => {
    const {
      minLength = 0,
      maxLength = 2 ** 32 - 2
    } = params;
    const informationPerItem = Inf.informationFromSampleSize(maxLength - minLength);
    return item => Inf.makeInformation(informationPerItem * item);
  },
  tuple: (_, ...items) => pipe(items, concatAll(N.MonoidProduct), _ => Inf.makeInformation(_))
};
//# sourceMappingURL=information.mjs.map