import { pipe, unsafeCoerce } from "fp-ts/es6/function.js";
import * as TE from "fp-ts/es6/TaskEither.js";
import * as TC from 'schemata-ts/internal/transcoder';
import { locationToIndex, replaceCharAt } from 'schemata-ts/schemables/check-digit/utils';
export const CheckDigitTranscoderPar = {
  checkDigit: (algorithm, location) => tc => ({
    encode: unsafeCoerce(tc.encode),
    decode: s => pipe(tc.decode(s), TE.chain(TE.fromPredicate(s => s[locationToIndex(s, location)] === algorithm(s), s => TC.transcodeErrors(TC.typeMismatch(replaceCharAt(s, locationToIndex(s, location), algorithm(s)), s)))))
  })
};
//# sourceMappingURL=transcoder-par.mjs.map