import * as E from "fp-ts/es6/Either.js";
import { pipe, unsafeCoerce } from "fp-ts/es6/function.js";
import * as TC from 'schemata-ts/internal/transcoder';
import { locationToIndex, replaceCharAt } from 'schemata-ts/schemables/check-digit/utils';
export const CheckDigitTranscoder = {
  checkDigit: (algorithm, location) => dec => ({
    encode: unsafeCoerce(dec.encode),
    decode: s => pipe(dec.decode(s), E.chain(E.fromPredicate(s => s[locationToIndex(s, location)] === algorithm(s), s => TC.transcodeErrors(TC.typeMismatch(replaceCharAt(s, locationToIndex(s, location), algorithm(s)), s)))))
  })
};
//# sourceMappingURL=transcoder.mjs.map