import * as Arb from 'schemata-ts/internal/arbitrary';
import { earliestSafeDate, isSafeDate, latestSafeDate } from 'schemata-ts/schemables/date/utils';
export const DateArbitrary = {
  date: (params = {}) => {
    const {
      beforeDate = latestSafeDate,
      afterDate = earliestSafeDate
    } = params;
    return Arb.makeArbitrary(fc => fc.date({
      min: afterDate,
      max: beforeDate
    }).filter(isSafeDate));
  },
  dateFromString: (params = {}) => {
    const {
      beforeDate,
      afterDate
    } = params;
    return Arb.makeArbitrary(fc => fc.date({
      min: afterDate,
      max: beforeDate
    }).filter(isSafeDate));
  }
};
//# sourceMappingURL=arbitrary.mjs.map