import { earliestSafeDate, isAfterInc, isBeforeInc, isSafeDate, latestSafeDate } from 'schemata-ts/schemables/date/utils';
export const DateGuard = {
  date: (params = {}) => {
    const {
      beforeDate = latestSafeDate,
      afterDate = earliestSafeDate
    } = params;
    return {
      is: u => isSafeDate(u) && isBeforeInc(afterDate)(u) && isAfterInc(beforeDate)(u)
    };
  },
  dateFromString: (params = {}) => {
    const {
      beforeDate = latestSafeDate,
      afterDate = earliestSafeDate
    } = params;
    return {
      is: i => isSafeDate(i) && isBeforeInc(afterDate)(i) && isAfterInc(beforeDate)(i)
    };
  }
};
//# sourceMappingURL=guard.mjs.map