/** @internal */
export function isSafeDate(d) {
  return d instanceof Date && !Number.isNaN(d.getTime());
}
/** @internal */

export const largestSafeMs = 8640000000000000;
/** @internal */

export const smallestSafeMs = -8640000000000000;
/** @internal */

export const isValidDateString = s => typeof s === 'string' && !Number.isNaN(new Date(s).getTime());
/** @internal */

export const isBeforeInc = d => d2 => d.getTime() <= d2.getTime();
/** @internal */

export const isAfterInc = d => d2 => d.getTime() >= d2.getTime();
/** @internal */

export const earliestSafeDate = /*#__PURE__*/new Date(smallestSafeMs);
/** @internal */

export const latestSafeDate = /*#__PURE__*/new Date(largestSafeMs);
export const getDateBoundsStr = ( // istanbul ignore next
params = {}) => {
  const {
    afterDate,
    beforeDate
  } = params;
  if (afterDate === undefined && beforeDate === undefined) return ''; // istanbul ignore next

  const beforeDateStr = beforeDate?.toISOString(); // istanbul ignore next

  const afterDateStr = afterDate?.toISOString();
  return `<${// istanbul ignore next
  afterDateStr ?? ''},${// istanbul ignore next
  beforeDateStr ?? ''}>`;
};
//# sourceMappingURL=utils.mjs.map