import { pipe } from "fp-ts/es6/function.js";
import * as RNEA from "fp-ts/es6/ReadonlyNonEmptyArray.js";
import * as Arb from 'schemata-ts/internal/arbitrary';
import { ordGuardedPrecedentedUnionMember } from 'schemata-ts/schemables/guarded-union/definition';
export const GuardedUnionArbitrary = {
  guardedUnion: (...members) => {
    const sortedMembers = pipe(members, RNEA.sort(ordGuardedPrecedentedUnionMember));
    return Arb.makeArbitrary(fc => fc.oneof(...sortedMembers.map(m => m.member.arbitrary(fc))));
  }
};
//# sourceMappingURL=arbitrary.mjs.map