import { pipe } from "fp-ts/es6/function.js";
import * as RNEA from "fp-ts/es6/ReadonlyNonEmptyArray.js";
import { ordGuardedPrecedentedUnionMember } from 'schemata-ts/schemables/guarded-union/definition';
export const GuardedUnionEq = {
  guardedUnion: (...members) => {
    const sortedMembers = pipe(members, RNEA.sort(ordGuardedPrecedentedUnionMember));
    return {
      equals: (x, y) => {
        for (const m of sortedMembers) {
          const {
            member,
            guard
          } = m;

          if (guard.is(x) && guard.is(y)) {
            return member.equals(x, y);
          }
        }

        return false;
      }
    };
  }
};
//# sourceMappingURL=eq.mjs.map