import { pipe } from "fp-ts/es6/function.js";
import * as RNEA from "fp-ts/es6/ReadonlyNonEmptyArray.js";
import { ordGuardedPrecedentedUnionMember } from 'schemata-ts/schemables/guarded-union/definition';
export const GuardedUnionGuard = {
  guardedUnion: (...members) => {
    const sortedMembers = pipe(members, RNEA.sort(ordGuardedPrecedentedUnionMember));
    return {
      is: u => {
        for (const m of sortedMembers) {
          const {
            guard
          } = m;

          if (guard.is(u)) {
            return true;
          }
        }

        return false;
      }
    };
  }
};
//# sourceMappingURL=guard.mjs.map