import * as B from "fp-ts/es6/boolean.js";
import { pipe } from "fp-ts/es6/function.js";
import * as RA from "fp-ts/es6/ReadonlyArray.js";
import * as JS from 'schemata-ts/internal/json-schema';
import { hasImplicitOptional, makeImplicitOptional } from 'schemata-ts/internal/struct';
export const GuardedUnionJsonSchema = {
  guardedUnion: (...members) => {
    const isOptional = pipe(members, RA.foldMap(B.MonoidAny)(({
      member
    }) => hasImplicitOptional(member)));
    const union = new JS.JsonUnion(members.map(({
      member
    }) => member));
    return members.length > 1 ? isOptional ? JS.make(makeImplicitOptional(union, _ => Object.assign({}, _))) : JS.make(union) : members[0].member;
  }
};
//# sourceMappingURL=json-schema.mjs.map