import { flow, pipe } from "fp-ts/es6/function.js";
import * as TE from "fp-ts/es6/TaskEither.js";
import * as TC from 'schemata-ts/internal/transcoder';
import { PrimitivesTranscoderPar } from 'schemata-ts/schemables/primitives/instances/transcoder-par';
import { TranscodeErrors } from 'schemata-ts/TranscodeError';
export const ParserTranscoderPar = {
  parse: (name, parse, print) => inner => ({
    encode: flow(inner.encode, TE.chain(encoded => pipe(print(encoded), TE.fromEither, TE.mapLeft(err => err instanceof TranscodeErrors ? err : TC.transcodeErrors(TC.serializationError(name, err, encoded)))))),
    decode: flow(PrimitivesTranscoderPar.string({
      errorName: name
    }).decode, TE.chain(preparsed => pipe(parse(preparsed), TE.fromEither, TE.mapLeft(err => err instanceof TranscodeErrors ? err : TC.transcodeErrors(TC.serializationError(name, err, preparsed))))), TE.chain(inner.decode))
  })
};
//# sourceMappingURL=transcoder-par.mjs.map