import * as B from "fp-ts/es6/boolean.js";
import { constant } from "fp-ts/es6/function.js";
import * as N from "fp-ts/es6/number.js";
import * as Str from "fp-ts/es6/string.js";
import * as Eq from 'schemata-ts/internal/eq';
export const PrimitivesEq = {
  string: /*#__PURE__*/constant(Str.Eq),
  int: /*#__PURE__*/constant(N.Eq),
  float: (params = {}) => {
    const {
      epsilon
    } = params;
    return Eq.fromEquals((x, y) => Math.abs(x - y) <= (epsilon ?? 2000 * Number.EPSILON));
  },
  boolean: B.Eq,
  // note: `fromEquals` first applies the equality check, which fails for NaN
  unknown: /*#__PURE__*/Eq.fromEquals((x, y) => Number.isNaN(x) && Number.isNaN(y)),
  literal: /*#__PURE__*/constant(Eq.eqStrict)
};
//# sourceMappingURL=eq.mjs.map