import * as Eq from "fp-ts/es6/Eq.js";
import { pipe } from "fp-ts/es6/function.js";
import * as RNEA from "fp-ts/es6/ReadonlyNonEmptyArray.js";
import * as Sg from "fp-ts/es6/Semigroup.js";
import * as Str from "fp-ts/es6/string.js";
import { makeTypeString } from 'schemata-ts/internal/type-string';
import { getLengthBoundsString, getNumberBoundsInt } from 'schemata-ts/schemables/primitives/utils';
export const PrimitivesTypeString = {
  string: (params = {}) => makeTypeString(`string${getLengthBoundsString(params, '<', '>')}`),
  int: (params = {}) => makeTypeString(`Integer${getNumberBoundsInt(params)}`),
  float: (params = {}) => makeTypeString(`Float${getNumberBoundsInt(params)}`),
  boolean: /*#__PURE__*/makeTypeString('boolean'),
  unknown: /*#__PURE__*/makeTypeString('unknown'),
  literal: (...items) => pipe(items, RNEA.uniq(Eq.eqStrict), RNEA.foldMap(Sg.intercalate(' | ')(Str.Semigroup))(String), _ => makeTypeString(`${_}`))
};
//# sourceMappingURL=type-string.mjs.map