import { pipe } from "fp-ts/es6/function.js";
import * as N from "fp-ts/es6/number.js";
import * as RNEA from "fp-ts/es6/ReadonlyNonEmptyArray.js";
import * as RR from "fp-ts/es6/ReadonlyRecord.js";
import * as Str from "fp-ts/es6/string.js";
import * as Inf from 'schemata-ts/internal/information';
import { remapPropertyKeys } from 'schemata-ts/schemables/struct/utils';
export const StructInformation = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip') => pipe(remapPropertyKeys(properties), RR.foldMap(Str.Ord)(N.MonoidProduct)(RNEA.foldMap(N.SemigroupSum)(({
    precedence
  }) => precedence)), _ => {
    if (typeof extraProps === 'string' || extraProps === undefined) return Inf.makeInformation(_);
    return Inf.makeInformation(_ + extraProps);
  }),
  record: (key, codomain) => pipe(Math.max(key, codomain), _ => Inf.makeInformation(_)),
  intersection: (x, y) => Inf.makeInformation(x * y - Math.min(x, y))
};
//# sourceMappingURL=information.mjs.map