import { pipe, tuple } from "fp-ts/es6/function.js";
import * as Mn from "fp-ts/es6/Monoid.js";
import * as RA from "fp-ts/es6/ReadonlyArray.js";
import * as RR from "fp-ts/es6/ReadonlyRecord.js";
import * as Sg from "fp-ts/es6/Semigroup.js";
import * as Str from "fp-ts/es6/string.js";
import * as JS from 'schemata-ts/internal/json-schema';
import { hasImplicitOptional } from 'schemata-ts/internal/struct';
export const StructJsonSchema = {
  struct: (properties, extraProps) => {
    const [requiredKeys, jsonSchema] = pipe(properties, RR.foldMapWithIndex(Str.Ord)(Mn.tuple(RA.getMonoid(), RR.getUnionMonoid(Sg.first())))((key, {
      schemable
    }) => tuple(hasImplicitOptional(schemable) ? [] : [key], {
      [key]: schemable
    })));
    return new JS.JsonStruct(jsonSchema, requiredKeys, extraProps === 'error' ? false : extraProps === 'strip' ? undefined : extraProps);
  },
  record: (keys, so) => JS.make(new JS.JsonStruct({}, [], so, keys)),
  intersection: (x, y) => JS.make(new JS.JsonIntersection([x, y]))
};
//# sourceMappingURL=json-schema.mjs.map