/** @since 1.0.0 */
import { pipe } from "fp-ts/es6/function.js";
import * as k from 'kuvio';
import { Brand } from 'schemata-ts/schemata/Brand';
import { Pattern } from 'schemata-ts/schemata/Pattern';
/**
 * @since 1.0.0
 * @category Pattern
 */

export const ascii = /*#__PURE__*/pipe( /*#__PURE__*/k.characterClass(false, [0x00, 0x7f]), /*#__PURE__*/k.atLeastOne());
/**
 * A string of ASCII characters.
 *
 * @since 1.0.0
 * @category String
 */

export const Ascii = /*#__PURE__*/Brand()( /*#__PURE__*/Pattern(ascii, 'Ascii'));
//# sourceMappingURL=Ascii.mjs.map