/** @since 1.0.0 */
import { pipe } from "fp-ts/es6/function.js";
import * as k from 'kuvio';
import { deriveGuard } from 'schemata-ts/Guard';
import { Boolean } from 'schemata-ts/schemata/Boolean';
import { Imap } from 'schemata-ts/schemata/Imap';
import { Pattern } from 'schemata-ts/schemata/Pattern';
/**
 * @since 1.0.0
 * @category Pattern
 */

export const booleanFromStringPattern = /*#__PURE__*/k.oneOf( /*#__PURE__*/k.exactString('true'), /*#__PURE__*/k.exactString('false'));
/**
 * A boolean value whose encoded representation is either "true" or "false".
 *
 * @since 1.0.0
 * @category Conversion
 */

export const BooleanFromString = /*#__PURE__*/pipe( /*#__PURE__*/Pattern(booleanFromStringPattern, ["'true' | 'false'", 'boolean']), /*#__PURE__*/Imap( /*#__PURE__*/deriveGuard(Boolean), s => s === 'true', b => b ? 'true' : 'false'));
//# sourceMappingURL=BooleanFromString.mjs.map