/** @since 2.0.0 */
import { identity, pipe } from "fp-ts/es6/function.js";
import { deriveGuard } from 'schemata-ts/derivations/guard-schemable';
import { camelCase } from 'schemata-ts/internal/camelcase';
import { Imap } from 'schemata-ts/schemata/Imap';
import { String } from 'schemata-ts/schemata/String';
/**
 * A schema that converts any string to camel-case
 *
 * @since 2.0.0
 * @category String
 */

export const CamelCaseString = params => {
  const string = String(params);
  return pipe(string, Imap(deriveGuard(string), camelCase, identity));
};
//# sourceMappingURL=CamelCaseString.mjs.map