/** @since 1.0.0 */
import { pipe } from "fp-ts/es6/function.js";
import * as k from 'kuvio';
import { luhn } from 'schemata-ts/internal/algorithms';
import { Brand } from 'schemata-ts/schemata/Brand';
import { CheckDigit } from 'schemata-ts/schemata/CheckDigit';
import { Pattern } from 'schemata-ts/schemata/Pattern';
/**
 * Represents a credit card number; currently this should accept Visa, Mastercard,
 * American Express, Diners Club, Discover, JCB, Rupay, and UnionPay.
 *
 * @since 1.0.0
 * @category String
 */

export const CreditCard = /*#__PURE__*/pipe( /*#__PURE__*/Pattern(k.patterns.creditCard, 'CreditCard'), /*#__PURE__*/CheckDigit(ccn => luhn(ccn.substring(0, ccn.length - 1)).toString(10), ccn => ccn.length - 1), /*#__PURE__*/Brand());
//# sourceMappingURL=CreditCard.mjs.map