/** @since 1.0.0 */
import { pipe } from "fp-ts/es6/function.js";
import { deriveGuard } from 'schemata-ts/derivations/guard-schemable';
import { Date as DateS } from 'schemata-ts/schemata/Date';
import { Imap } from 'schemata-ts/schemata/Imap';
import { Int } from 'schemata-ts/schemata/Int';
/**
 * Represents Date objects derived from time in milliseconds.
 *
 * @since 1.0.0
 * @category Conversion
 */

export const DateFromInt = /*#__PURE__*/pipe( /*#__PURE__*/Int({
  min: -8_640_000_000_000_000,
  max: 8_640_000_000_000_000
}), /*#__PURE__*/Imap( /*#__PURE__*/deriveGuard( /*#__PURE__*/DateS()), n => new Date(n), d => d.getTime()));
//# sourceMappingURL=DateFromInt.mjs.map