/** @since 1.0.0 */
import * as k from 'kuvio';
import { Brand } from 'schemata-ts/schemata/Brand';
import { Pattern } from 'schemata-ts/schemata/Pattern';
/**
 * @since 1.0.0
 * @category Pattern
 */

export const ethereumAddress = /*#__PURE__*/k.sequence( /*#__PURE__*/k.subgroup( /*#__PURE__*/k.exactString('0x')), /*#__PURE__*/k.exactly(40)(k.xdigit));
/**
 * Represents strings which are valid Ethereum addresses.
 *
 * @since 1.0.0
 * @category String
 */

export const EthereumAddress = /*#__PURE__*/Brand()( /*#__PURE__*/Pattern(ethereumAddress, 'EthereumAddress'));
//# sourceMappingURL=EthereumAddress.mjs.map