/** @since 1.0.0 */
import { maxNegativeFloat, minNegativeFloat } from 'schemata-ts/float';
import { Float as Floating } from 'schemata-ts/schemata/Float';
/**
 * Negative floating point branded newtype.
 *
 * Represents negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f < 0, f >= -Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const NegativeFloat = /*#__PURE__*/Floating({
  min: maxNegativeFloat,
  max: minNegativeFloat
});
//# sourceMappingURL=NegativeFloat.mjs.map