/** @since 1.0.0 */
import { minSafeInt } from 'schemata-ts/integer';
import { Int } from 'schemata-ts/schemata/Int';
/**
 * Negative integer branded newtype.
 *
 * Represents negative integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z < 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const NegativeInt = /*#__PURE__*/Int({
  min: minSafeInt,
  max: -1
});
//# sourceMappingURL=NegativeInt.mjs.map