/** @since 1.4.0 */
import { pipe } from "fp-ts/es6/function.js";
import { deriveGuard } from 'schemata-ts/Guard';
import { Imap } from 'schemata-ts/schemata/Imap';
/**
 * A schema for wrapping an inner schema's output value in a newtype.
 *
 * @since 1.4.0
 * @category Combinators
 */

export const Newtype = (iso, name) => _ => pipe(_, Imap(deriveGuard(_), iso.wrap, iso.unwrap, name));
//# sourceMappingURL=Newtype.mjs.map