/** @since 1.0.0 */
import { maxPositiveFloat } from 'schemata-ts/float';
import { Float as Floating } from 'schemata-ts/schemata/Float';
/**
 * Non-negative floating point branded newtype.
 *
 * Represents non-negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f >= 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const NonNegativeFloat = /*#__PURE__*/Floating({
  min: 0,
  max: maxPositiveFloat
});
//# sourceMappingURL=NonNegativeFloat.mjs.map