/** @since 1.0.0 */
import { maxNegativeFloat, minNegativeFloat } from 'schemata-ts/float';
import { Float as Floating } from 'schemata-ts/schemata/Float';
/**
 * Non-positive floating point branded newtype.
 *
 * Represents non-positive floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f <= 0, f >= -Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const NonPositiveFloat = /*#__PURE__*/Floating({
  min: maxNegativeFloat,
  max: minNegativeFloat
});
//# sourceMappingURL=NonPositiveFloat.mjs.map