/** @since 1.0.0 */
import { minSafeInt } from 'schemata-ts/integer';
import { Int } from 'schemata-ts/schemata/Int';
/**
 * NonPositive integer branded newtype.
 *
 * Represents integers which are negative or zero.
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z <= 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const NonPositiveInt = /*#__PURE__*/Int({
  min: minSafeInt,
  max: 0
});
//# sourceMappingURL=NonPositiveInt.mjs.map