/** @since 1.0.0 */
import { makeImplicitOptionalType } from 'schemata-ts/internal/struct';
import { Literal } from 'schemata-ts/schemata/Literal';
import { Optional } from 'schemata-ts/schemata/Optional';
import { Union } from 'schemata-ts/schemata/Union';
/**
 * Widens a schema to include null and undefined
 *
 * @since 1.0.0
 * @category Combinators
 */

export const Nullable = inner => makeImplicitOptionalType(Union(Literal(null), Optional(inner)));
//# sourceMappingURL=Nullable.mjs.map