/** @since 2.0.0 */
import { pipe } from "fp-ts/es6/function.js";
import { deriveTypeString } from 'schemata-ts/derivations/type-string-schemable';
import { Annotate } from 'schemata-ts/schemata/Annotate';
import { Literal } from 'schemata-ts/schemata/Literal';
import { Struct } from 'schemata-ts/schemata/Struct';
import { Union } from 'schemata-ts/schemata/Union';
/**
 * A schema that represents the `Option` type from fp-ts.
 *
 * @since 2.0.0
 * @category Combinators
 */

export const Option = inner => pipe(Union(Struct({
  _tag: Literal('None')
}), Struct({
  _tag: Literal('Some'),
  value: inner
})), Annotate({
  typeString: pipe(deriveTypeString(inner), ([input, output]) => `Option<${input}, ${output}>`)
}));
//# sourceMappingURL=Option.mjs.map