/** @since 1.0.0 */
import { unsafeCoerce } from "fp-ts/es6/function.js";
import { deriveTypeString } from 'schemata-ts/derivations/type-string-schemable';
import { make } from 'schemata-ts/internal/schema';
/**
 * A schema that widens a schema to include `undefined`. Also marks the input property of
 * a struct as optional.
 *
 * Optional property `fallbackInput` is used to provide a default value for transcoders
 * and json-schemas.
 *
 * @since 1.0.0
 * @category Combinators
 */

export const Optional = (target, fallbackInput) => unsafeCoerce(make(_ => _.optional(target.runSchema(_), deriveTypeString(target)[0], {
  fallbackInput
})));
//# sourceMappingURL=Optional.mjs.map