import * as E from "fp-ts/es6/Either.js";
import { identity, pipe, unsafeCoerce } from "fp-ts/es6/function.js";
import { deriveTypeString } from 'schemata-ts/derivations/type-string-schemable';
import { base64Decode, base64Encode } from 'schemata-ts/internal/util';
import { Annotate } from 'schemata-ts/schemata/Annotate';
import { ParseEncodedJsonString } from 'schemata-ts/schemata/ParseEncodedJson';
/**
 * Parses a base64-encoded and (URIComponent) escaped JSON string.
 *
 * @since 2.0.0
 * @category Printer Parsers
 */

export const ParseBase64Json = inner => pipe(inner, ParseEncodedJsonString(E.tryCatchK(input => decodeURIComponent(base64Decode(input)), identity), E.tryCatchK(input => base64Encode(encodeURIComponent(input)), identity), {
  contentEncoding: 'base64',
  contentMediaType: 'application/json',
  nameOverride: 'Base64'
}), Annotate({
  typeString: ['Base64', deriveTypeString(inner)[1]]
}), _ => unsafeCoerce(_));
//# sourceMappingURL=ParseBase64Json.mjs.map