import * as E from "fp-ts/es6/Either.js";
import { flow, pipe, unsafeCoerce } from "fp-ts/es6/function.js";
import * as J from "fp-ts/es6/Json.js";
import { deriveTypeString } from 'schemata-ts/derivations/type-string-schemable';
import { Parse } from 'schemata-ts/schemata/Parse';
/**
 * Applies a fallible string mapping function to a schema which parses a Json string.
 * Useful for things like conversion between character encodings.
 *
 * @since 2.0.0
 * @category Printer Parsers
 */

export const ParseEncodedJsonString = (decode, encode, options = {}) => inner => pipe(inner, Parse(options.nameOverride ?? deriveTypeString(inner)[0], flow(decode, E.chain(J.parse)), flow(J.stringify, E.chain(encode)), options), _ => unsafeCoerce(_));
//# sourceMappingURL=ParseEncodedJson.mjs.map