/** @since 1.0.0 */
import { maxPositiveFloat, minPositiveFloat } from 'schemata-ts/float';
import { Float as Floating } from 'schemata-ts/schemata/Float';
/**
 * Positive Float branded newtype.
 *
 * Represents floating point numbers:
 *
 * ```math
 *  { f | f ∈ R, f > 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const PositiveFloat = /*#__PURE__*/Floating({
  min: minPositiveFloat,
  max: maxPositiveFloat
});
//# sourceMappingURL=PositiveFloat.mjs.map