/** @since 1.0.0 */
import { maxSafeInt } from 'schemata-ts/integer';
import { Int } from 'schemata-ts/schemata/Int';
/**
 * Positive integer branded newtype.
 *
 * Represents positive integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z > 0, z <= 2 ** 53 - 1 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */

export const PositiveInt = /*#__PURE__*/Int({
  min: 1,
  max: maxSafeInt
});
//# sourceMappingURL=PositiveInt.mjs.map