/** @since 1.3.0 */
import { pipe } from "fp-ts/es6/function.js";
import * as RS from "fp-ts/es6/ReadonlySet.js";
import { deriveGuard } from 'schemata-ts/Guard';
import { Array as Array_ } from 'schemata-ts/schemata/Array';
import { Imap } from 'schemata-ts/schemata/Imap';

const getSetGuard = guard => ({
  is: u => u instanceof Set && pipe(u, RS.every(guard.is))
});
/**
 * An array input that's converted to a ReadonlySet.
 *
 * @since 1.3.0
 * @category Combinators
 */


export const SetFromArray = ordA => _ => pipe(Array_(_), Imap(getSetGuard(deriveGuard(_)), RS.fromReadonlyArray(ordA), RS.toReadonlyArray(ordA)));
//# sourceMappingURL=SetFromArray.mjs.map