"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveArbitrary = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var annotate = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/annotate/instances/arbitrary"));

var array = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/array/instances/arbitrary"));

var checkDigit = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/check-digit/instances/arbitrary"));

var clone = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/clone/instances/arbitrary"));

var date = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/date/instances/arbitrary"));

var guardedUnion = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/guarded-union/instances/arbitrary"));

var invariant = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/invariant/instances/arbitrary"));

var lazy = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/lazy/instances/arbitrary"));

var map = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/map/instances/arbitrary"));

var optional = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/optional/instances/arbitrary"));

var parser = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/parser/instances/arbitrary"));

var pattern = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/pattern/instances/arbitrary"));

var primitives = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/arbitrary"));

var refine = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/refine/instances/arbitrary"));

var struct = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/struct/instances/arbitrary"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @since 2.0.0
 * @category Instances
 */
const ArbitrarySchemable = { ...annotate.AnnotateArbitrary,
  ...array.ArrayArbitrary,
  ...checkDigit.CheckDigitArbitrary,
  ...clone.CloneArbitrary,
  ...date.DateArbitrary,
  ...guardedUnion.GuardedUnionArbitrary,
  ...invariant.InvariantArbitrary,
  ...lazy.LazyArbitrary,
  ...map.MapArbitrary,
  ...optional.OptionalArbitrary,
  ...parser.ParserArbitrary,
  ...pattern.PatternArbitrary,
  ...primitives.PrimitivesArbitrary,
  ...refine.RefineArbitrary,
  ...struct.StructArbitrary
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

const deriveArbitrary = /*#__PURE__*/(0, _schema.interpret)(ArbitrarySchemable);
exports.deriveArbitrary = deriveArbitrary;
//# sourceMappingURL=arbitrary-schemable.js.map