"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveEq = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var annotate = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/annotate/instances/eq"));

var array = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/array/instances/eq"));

var checkDigit = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/check-digit/instances/eq"));

var clone = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/clone/instances/eq"));

var date = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/date/instances/eq"));

var guardedUnion = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/guarded-union/instances/eq"));

var invariant = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/invariant/instances/eq"));

var lazy = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/lazy/instances/eq"));

var map = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/map/instances/eq"));

var optional = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/optional/instances/eq"));

var parser = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/parser/instances/eq"));

var pattern = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/pattern/instances/eq"));

var primitives = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/eq"));

var refine = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/refine/instances/eq"));

var struct = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/struct/instances/eq"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @since 2.0.0
 * @category Instances
 */
const EqSchemable = { ...annotate.AnnotateEq,
  ...array.ArrayEq,
  ...checkDigit.CheckDigitEq,
  ...clone.CloneEq,
  ...date.DateEq,
  ...guardedUnion.GuardedUnionEq,
  ...invariant.InvariantEq,
  ...lazy.LazyEq,
  ...map.MapEq,
  ...optional.OptionalEq,
  ...parser.ParserEq,
  ...pattern.PatternEq,
  ...primitives.PrimitivesEq,
  ...refine.RefineEq,
  ...struct.StructEq
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

const deriveEq = /*#__PURE__*/(0, _schema.interpret)(EqSchemable);
exports.deriveEq = deriveEq;
//# sourceMappingURL=eq-schemable.js.map