"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveInformation = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var annotate = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/annotate/instances/information"));

var array = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/array/instances/information"));

var checkDigit = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/check-digit/instances/information"));

var clone = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/clone/instances/information"));

var date = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/date/instances/information"));

var guardedUnion = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/guarded-union/instances/information"));

var invariant = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/invariant/instances/information"));

var lazy = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/lazy/instances/information"));

var map = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/map/instances/information"));

var optional = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/optional/instances/information"));

var parser = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/parser/instances/information"));

var pattern = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/pattern/instances/information"));

var primitives = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/information"));

var refine = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/refine/instances/information"));

var struct = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/struct/instances/information"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @since 2.0.0
 * @category Instances
 */
const InformationSchemable = { ...annotate.AnnotateInformation,
  ...array.ArrayInformation,
  ...checkDigit.CheckDigitInformation,
  ...clone.CloneInformation,
  ...date.DateInformation,
  ...guardedUnion.GuardedUnionInformation,
  ...invariant.InvariantInformation,
  ...lazy.LazyInformation,
  ...map.MapInformation,
  ...optional.OptionalInformation,
  ...parser.ParserInformation,
  ...pattern.PatternInformation,
  ...primitives.PrimitivesInformation,
  ...refine.RefineInformation,
  ...struct.StructInformation
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

const deriveInformation = /*#__PURE__*/(0, _schema.interpret)(InformationSchemable);
exports.deriveInformation = deriveInformation;
//# sourceMappingURL=information-schemable.js.map