"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveJsonSchema = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var annotate = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/annotate/instances/json-schema"));

var array = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/array/instances/json-schema"));

var checkDigit = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/check-digit/instances/json-schema"));

var clone = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/clone/instances/json-schema"));

var date = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/date/instances/json-schema"));

var guardedUnion = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/guarded-union/instances/json-schema"));

var invariant = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/invariant/instances/json-schema"));

var lazy = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/lazy/instances/json-schema"));

var map = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/map/instances/json-schema"));

var optional = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/optional/instances/json-schema"));

var parser = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/parser/instances/json-schema"));

var pattern = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/pattern/instances/json-schema"));

var primitives = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/json-schema"));

var refine = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/refine/instances/json-schema"));

var struct = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/struct/instances/json-schema"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @since 2.0.0
 * @category Instances
 */
const JsonSchemaSchemable = { ...annotate.AnnotateJsonSchema,
  ...array.ArrayJsonSchema,
  ...checkDigit.CheckDigitJsonSchema,
  ...clone.CloneJsonSchema,
  ...date.DateJsonSchema,
  ...guardedUnion.GuardedUnionJsonSchema,
  ...invariant.InvariantJsonSchema,
  ...lazy.LazyJsonSchema,
  ...map.MapJsonSchema,
  ...optional.OptionalJsonSchema,
  ...parser.ParserJsonSchema,
  ...pattern.PatternJsonSchema,
  ...primitives.PrimitivesJsonSchema,
  ...refine.RefineJsonSchema,
  ...struct.StructJsonSchema
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

const deriveJsonSchema = /*#__PURE__*/(0, _schema.interpret)(JsonSchemaSchemable);
exports.deriveJsonSchema = deriveJsonSchema;
//# sourceMappingURL=json-schema-schemable.js.map