"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveTranscoder = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var annotate = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/annotate/instances/transcoder"));

var array = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/array/instances/transcoder"));

var checkDigit = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/check-digit/instances/transcoder"));

var clone = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/clone/instances/transcoder"));

var date = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/date/instances/transcoder"));

var guardedUnion = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/guarded-union/instances/transcoder"));

var invariant = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/invariant/instances/transcoder"));

var lazy = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/lazy/instances/transcoder"));

var map = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/map/instances/transcoder"));

var optional = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/optional/instances/transcoder"));

var parser = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/parser/instances/transcoder"));

var pattern = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/pattern/instances/transcoder"));

var primitives = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/transcoder"));

var refine = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/refine/instances/transcoder"));

var struct = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/schemables/struct/instances/transcoder"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Schemable instances for Transcoder
 *
 * **Warning: DO NOT EDIT, this module is autogenerated**
 *
 * @since 2.0.0
 */

/**
 * @since 2.0.0
 * @category Instances
 */
const TranscoderSchemable = { ...annotate.AnnotateTranscoder,
  ...array.ArrayTranscoder,
  ...checkDigit.CheckDigitTranscoder,
  ...clone.CloneTranscoder,
  ...date.DateTranscoder,
  ...guardedUnion.GuardedUnionTranscoder,
  ...invariant.InvariantTranscoder,
  ...lazy.LazyTranscoder,
  ...map.MapTranscoder,
  ...optional.OptionalTranscoder,
  ...parser.ParserTranscoder,
  ...pattern.PatternTranscoder,
  ...primitives.PrimitivesTranscoder,
  ...refine.RefineTranscoder,
  ...struct.StructTranscoder
};
/**
 * @since 2.0.0
 * @category Interpreters
 */

const deriveTranscoder = /*#__PURE__*/(0, _schema.interpret)(TranscoderSchemable);
exports.deriveTranscoder = deriveTranscoder;
//# sourceMappingURL=transcoder-schemable.js.map