"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.luhn = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _number = /*#__PURE__*/require("fp-ts/lib/number.js");

var RA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyArray.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * This calculates the Luhn checksum for a given string of digits.
 *
 * @internal
 */
const luhn = /*#__PURE__*/(0, _function.flow)( /*#__PURE__*/Str.split(''), RA.reverse, /*#__PURE__*/RA.map(d => parseInt(d)), /*#__PURE__*/RA.foldMapWithIndex(_number.MonoidSum)((i, d) => i % 2 === 1 ? // numbers of odd rank stay the same
d : // numbers of even rank get doubled, then their digits are summed
d * 2 >= 10 ? 1 + (d * 2 - 10) : d * 2), sum => (10 - sum % 10) % 10);
exports.luhn = luhn;
//# sourceMappingURL=algorithms.js.map