"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.imap = exports.fromEquals = exports.eqStrict = exports.contramap = void 0;

/** @internal */
const fromEquals = equals => ({
  equals: (x, y) => x === y || equals(x, y)
});
/** @internal */


exports.fromEquals = fromEquals;
const eqStrict = {
  equals: (x, y) => x === y
};
/** @internal */

exports.eqStrict = eqStrict;

const contramap = f => fa => fromEquals((x, y) => fa.equals(f(x), f(y)));
/** @internal */
//


exports.contramap = contramap;

const imap = (_, g) => fa => contramap(g)(fa);

exports.imap = imap;
//# sourceMappingURL=eq.js.map