"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeInformation = exports.informationFromSampleSize = void 0;

var _Const = /*#__PURE__*/require("fp-ts/lib/Const.js");

/**
 * A schemable for determining information entropy of a schema.
 *
 * @since 2.0.0
 */

/** @internal */
const makeInformation = e => (0, _Const.make)(Math.min(e, Number.MAX_VALUE));
/** @internal */


exports.makeInformation = makeInformation;

const informationFromSampleSize = sampleSize => sampleSize <= 0 ? makeInformation(0) : makeInformation(Math.log2(sampleSize));

exports.informationFromSampleSize = informationFromSampleSize;
//# sourceMappingURL=information.js.map