"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeMergeSemigroup = exports.identity = exports.constSemigroup = void 0;

var _Semigroup = /*#__PURE__*/require("fp-ts/lib/Semigroup.js");

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

// istanbul ignore next

/** @internal */
const identity = choice => constSemigroup((concrete = 'last') => {
  if (concrete === 'last') {
    return (0, _Semigroup.last)();
  }

  if (concrete === 'first') {
    return (0, _Semigroup.first)();
  }

  const _ = concrete[choice];

  if (typeof _ !== 'string' && _ !== undefined) {
    return _;
  }

  if (_ === 'first') {
    return (0, _Semigroup.first)();
  }

  if (_ === 'last') {
    return (0, _Semigroup.last)();
  }

  return concrete['fallback'] === 'last' ? (0, _Semigroup.last)() : (0, _Semigroup.first)();
});
/** @internal */


exports.identity = identity;

const constSemigroup = make => ({
  semigroup: (0, _schema.memoize)(make)
});
/** @internal */


exports.constSemigroup = constSemigroup;

const makeMergeSemigroup = make => ({
  semigroup: (0, _schema.memoize)(concrete => ({
    concat: make(concrete)
  }))
});

exports.makeMergeSemigroup = makeMergeSemigroup;
//# sourceMappingURL=merge-semigroup.js.map