"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.success = exports.imap = exports.fromTranscoder = exports.failure = exports.applicativeValidationPar = exports.apSecond = exports.apS = void 0;

var Ap = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Apply.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var T = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Task.js"));

var TE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/TaskEither.js"));

var TCE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/TranscodeError"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @internal */
const success = TE.right;
/** @internal */

exports.success = success;
const failure = TE.throwError;
/** @internal */

exports.failure = failure;
const applicativeValidationPar = /*#__PURE__*/TE.getApplicativeTaskValidation(T.ApplicativePar, TCE.Semigroup);
/** @internal */

exports.applicativeValidationPar = applicativeValidationPar;
const apSecond = /*#__PURE__*/Ap.apSecond(applicativeValidationPar);
/** @internal */

exports.apSecond = apSecond;
const apS = /*#__PURE__*/Ap.apS(applicativeValidationPar);
/** @internal */

exports.apS = apS;

const fromTranscoder = tc => ({
  decode: (0, _function.flow)(tc.decode, TE.fromEither),
  encode: (0, _function.flow)(tc.encode, TE.fromEither)
});
/** @internal */


exports.fromTranscoder = fromTranscoder;

const imap = (f, g) => fa => ({
  decode: u => TE.Functor.map(fa.decode(u), f),
  encode: out => fa.encode(g(out))
});

exports.imap = imap;
//# sourceMappingURL=transcoder-par.js.map