"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unexpectedValue = exports.typeMismatch = exports.transcodeErrors = exports.success = exports.serializationError = exports.imap = exports.fromGuard = exports.failure = exports.errorAtUnionMember = exports.errorAtKey = exports.errorAtIndex = exports.applicativeValidation = exports.apSecond = exports.apS = void 0;

var Ap = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Apply.js"));

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var TE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/TranscodeError"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @internal */
const success = E.right;
/** @internal */

exports.success = success;
const failure = E.throwError;
/** @internal */

exports.failure = failure;

const transcodeErrors = (...errors) => new TE.TranscodeErrors(errors);
/** @internal */


exports.transcodeErrors = transcodeErrors;

const typeMismatch = (...args) => new TE.TypeMismatch(...args);
/** @internal */


exports.typeMismatch = typeMismatch;

const unexpectedValue = (...args) => new TE.UnexpectedValue(...args);
/** @internal */


exports.unexpectedValue = unexpectedValue;

const serializationError = (...args) => new TE.SerializationError(...args);
/** @internal */


exports.serializationError = serializationError;

const errorAtIndex = (...args) => new TE.ErrorAtIndex(...args);
/** @internal */


exports.errorAtIndex = errorAtIndex;

const errorAtKey = (...args) => new TE.ErrorAtKey(...args);
/** @internal */


exports.errorAtKey = errorAtKey;

const errorAtUnionMember = (...args) => new TE.ErrorAtUnionMember(...args);
/** @internal */


exports.errorAtUnionMember = errorAtUnionMember;
const applicativeValidation = /*#__PURE__*/E.getApplicativeValidation(TE.Semigroup);
/** @internal */

exports.applicativeValidation = applicativeValidation;
const apSecond = /*#__PURE__*/Ap.apSecond(applicativeValidation);
/** @internal */

exports.apSecond = apSecond;
const apS = /*#__PURE__*/Ap.apS(applicativeValidation);
/** @internal */

exports.apS = apS;

const fromGuard = (encode, onError) => guard => ({
  decode: E.fromPredicate(guard.is, onError),
  encode: (0, _function.flow)(encode, E.right)
});
/** @internal */


exports.fromGuard = fromGuard;

const imap = (f, g) => fa => ({
  decode: u => E.Functor.map(fa.decode(u), f),
  encode: out => fa.encode(g(out))
});

exports.imap = imap;
//# sourceMappingURL=transcoder.js.map