"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.witherRemapPar = exports.witherRemap = exports.hasOwn = exports.base64Encode = exports.base64Decode = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RR = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyRecord.js"));

var T = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Task.js"));

var TE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/TaskEither.js"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* istanbul ignore next */

/** @internal */
const base64Encode = s => {
  try {
    return Buffer ? Buffer.from(s).toString('base64') : btoa(s);
  } catch (_) {
    return btoa(s);
  }
}; // istanbul ignore next

/** @internal */


exports.base64Encode = base64Encode;

const base64Decode = s => {
  try {
    return Buffer ? Buffer.from(s, 'base64').toString() : atob(s);
  } catch (_) {
    return atob(s);
  }
};
/* istanbul ignore next */

/**
 * Object.hasOwn isn't available in Node 14 :(
 *
 * @internal
 */
// eslint-disable-next-line @typescript-eslint/ban-types


exports.base64Decode = base64Decode;

const hasOwn = (o, v) => Object.hasOwn ? Object.hasOwn(o, v) : Object.prototype.hasOwnProperty.call(o, v);
/**
 * Performs a validative traversal over a struct's own enumerable properties while mapping
 * output types.
 *
 * @internal
 */


exports.hasOwn = hasOwn;

const witherRemap = sgErrors => f => s => {
  const effects = {};
  /* Enumerable own, Enumerable inherited */

  for (const key in s) {
    /* Ignores inherited properties */
    // istanbul ignore next
    if (!hasOwn(s, key)) continue;
    /* Perform effect */

    effects[key] = f(key, s[key]);
  }

  return (0, _function.pipe)(effects, RR.wither(E.getApplicativeValidation(sgErrors))(_function.identity), E.map(s => {
    const out = {};

    for (const key in s) {
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      const [value, newKey, semigroup] = s[key];

      if (hasOwn(out, newKey)) {
        out[newKey] = semigroup.concat(out[newKey], value);
        continue;
      }

      out[newKey] = value;
    }

    return out;
  }));
};

exports.witherRemap = witherRemap;

const getApplicativeValidationPar = sgErrors => TE.getApplicativeTaskValidation(T.ApplicativePar, sgErrors);
/** Performs a task-validative traversal over a struct's own enumerable properties. */


const witherRemapPar = sgErrors => f => s => {
  const effects = {};
  /* Enumerable own, Enumerable inherited */

  for (const key in s) {
    /* Ignores inherited properties */
    // istanbul ignore next
    if (!hasOwn(s, key)) continue;
    /* Perform effect */

    effects[key] = f(key, s[key]);
  }

  return (0, _function.pipe)(effects, RR.wither(getApplicativeValidationPar(sgErrors))(_function.identity), TE.map(s => {
    const out = {};

    for (const key in s) {
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      const [value, newKey, semigroup] = s[key];

      if (hasOwn(out, newKey)) {
        out[newKey] = semigroup.concat(out[newKey], value);
        continue;
      }

      out[newKey] = value;
    }

    return out;
  }));
};

exports.witherRemapPar = witherRemapPar;
//# sourceMappingURL=util.js.map