"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnnotateJsonSchema = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var JS = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/json-schema"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const AnnotateJsonSchema = {
  annotate: params => inner => {
    const {
      title,
      description,
      references,
      deprecated,
      readOnly
    } = params;
    const hasChanged = title !== undefined || description !== undefined || deprecated !== undefined || readOnly !== undefined;
    return (0, _function.pipe)(inner, hasChanged ? JS.addDescription({ ...(title === undefined ? {} : {
        title
      }),
      ...(description === undefined ? {} : {
        description
      }),
      ...(deprecated === undefined ? {} : {
        deprecated
      }),
      ...(readOnly === undefined ? {} : {
        readOnly
      })
    }) : _function.identity, references !== undefined ? JS.addReferences({
      $defs: references
    }) : _function.identity);
  }
};
exports.AnnotateJsonSchema = AnnotateJsonSchema;
//# sourceMappingURL=json-schema.js.map