"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArrayGuard = void 0;
const ArrayGuard = {
  array: params => {
    const {
      minLength = 0,
      maxLength = 2 ** 32 - 2
    } = params;
    return item => ({
      is: u => Array.isArray(u) && u.length >= minLength && u.length <= maxLength && u.every(item.is)
    });
  },
  tuple: (_, ...items) => ({
    is: u => Array.isArray(u) && u.length === items.length && // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    u.every((a, i) => items[i].is(a))
  })
};
exports.ArrayGuard = ArrayGuard;
//# sourceMappingURL=guard.js.map