"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArrayInformation = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _Monoid = /*#__PURE__*/require("fp-ts/lib/Monoid.js");

var N = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/number.js"));

var Inf = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/information"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ArrayInformation = {
  array: params => {
    const {
      minLength = 0,
      maxLength = 2 ** 32 - 2
    } = params;
    const informationPerItem = Inf.informationFromSampleSize(maxLength - minLength);
    return item => Inf.makeInformation(informationPerItem * item);
  },
  tuple: (_, ...items) => (0, _function.pipe)(items, (0, _Monoid.concatAll)(N.MonoidProduct), _ => Inf.makeInformation(_))
};
exports.ArrayInformation = ArrayInformation;
//# sourceMappingURL=information.js.map