"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArrayTranscoder = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyArray.js"));

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const validateArray = name => E.fromPredicate(u => Array.isArray(u), u => TC.transcodeErrors(TC.typeMismatch(name, u)));

const ArrayTranscoder = {
  array: params => {
    const {
      minLength = 0,
      maxLength = 2 ** 32 - 2,
      expectedName
    } = params;
    return item => ({
      encode: E.traverseArrayWithIndex((i, a) => (0, _function.pipe)(item.encode(a), E.mapLeft(errs => TC.transcodeErrors(TC.errorAtIndex(i, errs))))),
      decode: (0, _function.flow)(validateArray(expectedName), E.chain(u => (0, _function.pipe)(u, E.fromPredicate(u => u.length >= minLength && u.length <= maxLength, u => TC.transcodeErrors(TC.typeMismatch(expectedName, `Array(${u.length})`))), TC.apSecond((0, _function.pipe)(u, validateArray(expectedName), E.chain(RA.traverseWithIndex(TC.applicativeValidation)((i, u) => (0, _function.pipe)(item.decode(u), E.mapLeft(errs => TC.transcodeErrors(TC.errorAtIndex(i, errs)))))))))))
    });
  },
  tuple: (name, ...components) => ({
    encode: out => (0, _function.unsafeCoerce)(RA.sequence(TC.applicativeValidation)(RA.zipWith(out, components, (a, encoderA) => encoderA.encode(a)))),
    decode: (0, _function.flow)(validateArray(name), E.filterOrElse(u => u.length === components.length, u => TC.transcodeErrors(TC.typeMismatch(name, u))), E.chain(RA.traverseWithIndex(TC.applicativeValidation)((i, u) => (0, _function.pipe)( // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    components[i].decode(u), E.mapLeft(err => TC.transcodeErrors(TC.errorAtIndex(i, err)))))), E.map(a => (0, _function.unsafeCoerce)(a)))
  })
};
exports.ArrayTranscoder = ArrayTranscoder;
//# sourceMappingURL=transcoder.js.map