"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateGuard = void 0;

var _utils = /*#__PURE__*/require("schemata-ts/schemables/date/utils");

const DateGuard = {
  date: (params = {}) => {
    const {
      beforeDate = _utils.latestSafeDate,
      afterDate = _utils.earliestSafeDate
    } = params;
    return {
      is: u => (0, _utils.isSafeDate)(u) && (0, _utils.isBeforeInc)(afterDate)(u) && (0, _utils.isAfterInc)(beforeDate)(u)
    };
  },
  dateFromString: (params = {}) => {
    const {
      beforeDate = _utils.latestSafeDate,
      afterDate = _utils.earliestSafeDate
    } = params;
    return {
      is: i => (0, _utils.isSafeDate)(i) && (0, _utils.isBeforeInc)(afterDate)(i) && (0, _utils.isAfterInc)(beforeDate)(i)
    };
  }
};
exports.DateGuard = DateGuard;
//# sourceMappingURL=guard.js.map