"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateInformation = void 0;

var Inf = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/information"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/date/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const informationFromDateRange = (beforeDate, afterDate) => {
  const dyr = beforeDate.getFullYear() - afterDate.getFullYear();
  const dmo = beforeDate.getMonth() - afterDate.getMonth();
  const dd = beforeDate.getDate() - afterDate.getDate();
  const dhr = beforeDate.getHours() - afterDate.getHours();
  const dmi = beforeDate.getMinutes() - afterDate.getMinutes();
  const ds = beforeDate.getSeconds() - afterDate.getSeconds();
  const dms = beforeDate.getMilliseconds() - afterDate.getMilliseconds();
  return Inf.informationFromSampleSize(Math.abs(dyr * dmo * dd * dhr * dmi * ds * dms));
};

const DateInformation = {
  date: (params = {}) => {
    const {
      beforeDate = _utils.latestSafeDate,
      afterDate = _utils.earliestSafeDate
    } = params;
    return informationFromDateRange(beforeDate, afterDate);
  },
  dateFromString: (params = {}) => {
    const {
      beforeDate = _utils.latestSafeDate,
      afterDate = _utils.earliestSafeDate
    } = params;
    return informationFromDateRange(beforeDate, afterDate);
  }
};
exports.DateInformation = DateInformation;
//# sourceMappingURL=information.js.map