"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateTranscoder = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Pred = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Predicate.js"));

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

var _guard = /*#__PURE__*/require("schemata-ts/schemables/date/instances/guard");

var _utils = /*#__PURE__*/require("schemata-ts/schemables/date/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const DateTranscoder = {
  date: params => (0, _function.pipe)(_guard.DateGuard.date(params), TC.fromGuard(_function.identity, u => TC.transcodeErrors(TC.typeMismatch(`Date${(0, _utils.getDateBoundsStr)(params)}`, u)))),
  dateFromString: (params = {}) => {
    const {
      beforeDate = _utils.latestSafeDate,
      afterDate = _utils.earliestSafeDate
    } = params;
    return {
      encode: date => E.right((0, _function.unsafeCoerce)(date.toISOString())),
      decode: u => (0, _function.pipe)(u, E.fromPredicate(_utils.isValidDateString, () => TC.transcodeErrors(TC.typeMismatch(`DateString${(0, _utils.getDateBoundsStr)(params)}`, u))), E.map(ds => new Date(ds)), E.filterOrElse(Pred.and((0, _utils.isBeforeInc)(afterDate))((0, _utils.isAfterInc)(beforeDate)), () => TC.transcodeErrors(TC.typeMismatch(`DateString${(0, _utils.getDateBoundsStr)(params)}`, u))), E.map(_ => (0, _function.unsafeCoerce)(_)))
    };
  }
};
exports.DateTranscoder = DateTranscoder;
//# sourceMappingURL=transcoder.js.map