"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GuardedUnionGuard = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var _definition = /*#__PURE__*/require("schemata-ts/schemables/guarded-union/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const GuardedUnionGuard = {
  guardedUnion: (...members) => {
    const sortedMembers = (0, _function.pipe)(members, RNEA.sort(_definition.ordGuardedPrecedentedUnionMember));
    return {
      is: u => {
        for (const m of sortedMembers) {
          const {
            guard
          } = m;

          if (guard.is(u)) {
            return true;
          }
        }

        return false;
      }
    };
  }
};
exports.GuardedUnionGuard = GuardedUnionGuard;
//# sourceMappingURL=guard.js.map