"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GuardedUnionTranscoderPar = void 0;

var _Alt = /*#__PURE__*/require("fp-ts/lib/Alt.js");

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyArray.js"));

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var TE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/TaskEither.js"));

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

var TCP = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder-par"));

var _definition = /*#__PURE__*/require("schemata-ts/schemables/guarded-union/definition");

var TCE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/TranscodeError"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const altValidation = /*#__PURE__*/TE.getAltTaskValidation(TCE.Semigroup);
const GuardedUnionTranscoderPar = {
  guardedUnion: (...members) => {
    const sortedMembers = (0, _function.pipe)(members, RNEA.sort(_definition.ordGuardedPrecedentedUnionMember));
    const firstMember = RNEA.head(sortedMembers);
    const tailMembers = RNEA.tail(sortedMembers);
    return {
      encode: out => {
        for (const m of sortedMembers) {
          const {
            guard,
            member
          } = m;

          if (guard.is(out)) {
            return member.encode(out);
          }
        }

        return (0, _function.pipe)(sortedMembers, RNEA.map(({
          name
        }) => TC.errorAtUnionMember(name, TC.transcodeErrors(TC.typeMismatch(name, out)))), errs => TC.transcodeErrors(...errs), TCP.failure);
      },
      decode: u => (0, _function.pipe)(tailMembers, RA.map(_ => (0, _function.pipe)(_.member.decode(u), TE.mapLeft(errors => TC.transcodeErrors(TC.errorAtUnionMember(_.name, errors))))), (0, _Alt.altAll)(altValidation)((0, _function.pipe)(firstMember.member.decode(u), TE.mapLeft(errors => sortedMembers.length > 1 ? TC.transcodeErrors(TC.errorAtUnionMember(firstMember.name, errors)) : errors))))
    };
  }
};
exports.GuardedUnionTranscoderPar = GuardedUnionTranscoderPar;
//# sourceMappingURL=transcoder-par.js.map