"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesArbitrary = void 0;

var Arb = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/arbitrary"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/primitives/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PrimitivesArbitrary = {
  string: params => Arb.makeArbitrary(fc => fc.oneof(fc.string(params), fc.asciiString(params), fc.hexaString(params), fc.base64String(params))),
  int: (params = {}) => {
    const {
      min = Number.MIN_SAFE_INTEGER,
      max = Number.MAX_SAFE_INTEGER
    } = params;
    return Arb.makeArbitrary(fc => fc.integer({
      min: Math.floor(Math.max(min, Number.MIN_SAFE_INTEGER)),
      max: Math.floor(Math.min(max, Number.MAX_SAFE_INTEGER))
    }).filter((0, _utils.isInt)(params)));
  },

  float(params = {}) {
    const {
      min = -Number.MAX_VALUE,
      max = Number.MAX_VALUE
    } = params;
    return Arb.makeArbitrary(fc => fc.double({
      min: Math.max(min, -Number.MAX_VALUE),
      max: Math.min(max, Number.MAX_VALUE),
      noDefaultInfinity: true,
      noNaN: true
    }).filter((0, _utils.isFloat)(params)));
  },

  boolean: /*#__PURE__*/Arb.makeArbitrary(fc => fc.boolean()),
  unknown: /*#__PURE__*/Arb.makeArbitrary(fc => fc.anything()),
  literal: (...literals) => Arb.makeArbitrary(fc => fc.oneof(...literals.map(v => fc.constant(v))))
};
exports.PrimitivesArbitrary = PrimitivesArbitrary;
//# sourceMappingURL=arbitrary.js.map