"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesEq = void 0;

var B = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/boolean.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var N = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/number.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var Eq = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/eq"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PrimitivesEq = {
  string: /*#__PURE__*/(0, _function.constant)(Str.Eq),
  int: /*#__PURE__*/(0, _function.constant)(N.Eq),
  float: (params = {}) => {
    const {
      epsilon
    } = params;
    return Eq.fromEquals((x, y) => Math.abs(x - y) <= (epsilon ?? 2000 * Number.EPSILON));
  },
  boolean: B.Eq,
  // note: `fromEquals` first applies the equality check, which fails for NaN
  unknown: /*#__PURE__*/Eq.fromEquals((x, y) => Number.isNaN(x) && Number.isNaN(y)),
  literal: /*#__PURE__*/(0, _function.constant)(Eq.eqStrict)
};
exports.PrimitivesEq = PrimitivesEq;
//# sourceMappingURL=eq.js.map