"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesGuard = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var G = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/guard"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/primitives/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const isString = s => typeof s === 'string';

const isBoolean = b => typeof b === 'boolean';

const isNumber = n => typeof n === 'number';

const isNull = n => n === null;

const PrimitivesGuard = {
  string: (params = {}) => ({
    is: s => isString(s) && (params.minLength === undefined || s.length >= params.minLength) && (params.maxLength === undefined || s.length <= params.maxLength)
  }),
  int: /*#__PURE__*/(0, _function.flow)(_utils.isInt, G.fromPredicate),
  float: /*#__PURE__*/(0, _function.flow)(_utils.isFloat, G.fromPredicate),
  boolean: /*#__PURE__*/G.fromPredicate(isBoolean),
  unknown: {
    is: _ => true
  },
  literal: (...literals) => ({
    is: u => (isString(u) || isNumber(u) || isBoolean(u) || isNull(u)) && literals.includes(u)
  })
};
exports.PrimitivesGuard = PrimitivesGuard;
//# sourceMappingURL=guard.js.map