"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesJsonSchema = void 0;

var JS = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/json-schema"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PrimitivesJsonSchema = {
  string: (params = {}) => JS.make(new JS.JsonString(params.minLength, params.maxLength)),
  int: (params = {}) => JS.make(new JS.JsonInteger(params.min, params.max)),
  float: (params = {}) => JS.make(new JS.JsonNumber(params.min, params.max)),
  boolean: /*#__PURE__*/JS.make( /*#__PURE__*/new JS.JsonBoolean()),
  unknown: /*#__PURE__*/JS.make( /*#__PURE__*/new JS.JsonEmpty()),
  literal: (...literals) => JS.make(literals.length === 1 ? literals[0] === null ? new JS.JsonNull() : {
    type: typeof literals[0],
    const: literals[0]
  } : new JS.JsonUnion(literals.map(literal => literal === null ? new JS.JsonNull() : {
    type: typeof literal,
    const: literal
  })))
};
exports.PrimitivesJsonSchema = PrimitivesJsonSchema;
//# sourceMappingURL=json-schema.js.map