"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesTranscoder = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

var _guard = /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/guard");

var _typeString = /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/type-string");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PrimitivesTranscoder = {
  string: _ => (0, _function.pipe)(_, _guard.PrimitivesGuard.string, TC.fromGuard(_function.identity, u => TC.transcodeErrors(TC.typeMismatch(_?.errorName ?? _typeString.PrimitivesTypeString.string(_)[0], u)))),
  int: _ => (0, _function.pipe)(_, _guard.PrimitivesGuard.int, TC.fromGuard(_function.identity, u => TC.transcodeErrors(TC.typeMismatch(_?.errorName ?? _typeString.PrimitivesTypeString.int(_)[0], u)))),
  float: _ => (0, _function.pipe)(_, _guard.PrimitivesGuard.float, TC.fromGuard(_function.identity, u => TC.transcodeErrors(TC.typeMismatch(_?.errorName ?? _typeString.PrimitivesTypeString.float(_)[0], u)))),
  boolean: /*#__PURE__*/(0, _function.pipe)(_guard.PrimitivesGuard.boolean, /*#__PURE__*/TC.fromGuard(_function.identity, u => TC.transcodeErrors(TC.typeMismatch('boolean', u)))),
  unknown: {
    decode: TC.success,
    encode: TC.success
  },
  literal: (...literals) => (0, _function.pipe)(_guard.PrimitivesGuard.literal(...literals), TC.fromGuard(_function.identity, u => (0, _function.pipe)(literals, RNEA.mapWithIndex((i, literal) => literals.length > 1 ? TC.errorAtUnionMember(i, TC.transcodeErrors(TC.typeMismatch(String(literal), u))) : TC.typeMismatch(String(literal), u)), errs => TC.transcodeErrors(...errs))))
};
exports.PrimitivesTranscoder = PrimitivesTranscoder;
//# sourceMappingURL=transcoder.js.map