"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrimitivesTypeString = void 0;

var Eq = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Eq.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var _typeString = /*#__PURE__*/require("schemata-ts/internal/type-string");

var _utils = /*#__PURE__*/require("schemata-ts/schemables/primitives/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PrimitivesTypeString = {
  string: (params = {}) => (0, _typeString.makeTypeString)(`string${(0, _utils.getLengthBoundsString)(params, '<', '>')}`),
  int: (params = {}) => (0, _typeString.makeTypeString)(`Integer${(0, _utils.getNumberBoundsInt)(params)}`),
  float: (params = {}) => (0, _typeString.makeTypeString)(`Float${(0, _utils.getNumberBoundsInt)(params)}`),
  boolean: /*#__PURE__*/(0, _typeString.makeTypeString)('boolean'),
  unknown: /*#__PURE__*/(0, _typeString.makeTypeString)('unknown'),
  literal: (...items) => (0, _function.pipe)(items, RNEA.uniq(Eq.eqStrict), RNEA.foldMap(Sg.intercalate(' | ')(Str.Semigroup))(String), _ => (0, _typeString.makeTypeString)(`${_}`))
};
exports.PrimitivesTypeString = PrimitivesTypeString;
//# sourceMappingURL=type-string.js.map