"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructArbitrary = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Arb = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/arbitrary"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const readonly = _function.identity;
const StructArbitrary = {
  struct: (properties, // istanbul ignore next
  extraParams = 'strip') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties, i => 1000 / i);
    const collapsedArbs = {};

    for (const key in lookupByOutputKey) {
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      const arbs = lookupByOutputKey[key];
      collapsedArbs[key] = arbs.length === 1 ? Arb.makeArbitrary(fc => arbs[0].member.arbitrary(fc)) : Arb.makeArbitrary(fc => fc.oneof(...arbs.map(({
        member,
        precedence
      }) => ({
        arbitrary: member.arbitrary(fc),
        weight: Math.ceil(precedence)
      }))));
    }

    return Arb.makeArbitrary(fc => {
      const out = {};

      for (const key in collapsedArbs) {
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        const arb = collapsedArbs[key];
        out[key] = arb.arbitrary(fc);
      }

      if (typeof extraParams !== 'string') {
        return fc.tuple(fc.record(out), fc.dictionary(fc.string().filter(k => k !== '__proto__'), extraParams.arbitrary(fc))).map(([a, b]) => (0, _utils.safeIntersect)(a, b));
      }

      return fc.record(out);
    });
  },
  record: (key, codomain) => Arb.makeArbitrary(fc => fc.dictionary(key.arbitrary(fc).filter(k => k !== '__proto__'), codomain.arbitrary(fc)).map(readonly)),
  intersection: (xs, ys) => Arb.makeArbitrary(fc => fc.tuple(xs.arbitrary(fc), ys.arbitrary(fc)).map(([x, y]) => (0, _utils.safeIntersect)(x, y)))
};
exports.StructArbitrary = StructArbitrary;
//# sourceMappingURL=arbitrary.js.map