"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructEq = void 0;

var B = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/boolean.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RR = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyRecord.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var Eq = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/eq"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const StructEq = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties);
    return Eq.fromEquals((x, y) => {
      const keysX = Object.keys(x);
      const keysY = Object.keys(y);
      if (keysX.length !== keysY.length) return false;
      const knownEqual = (0, _function.pipe)(lookupByOutputKey, RR.foldMapWithIndex(Str.Ord)(B.MonoidAll)((key, eqs) => {
        for (const {
          member,
          guard
        } of eqs) {
          if (guard.is(x[key]) && guard.is(y[key])) {
            return member.equals(x[key], y[key]);
          }
        }

        return false;
      }));
      if (typeof extraProps === 'string') return knownEqual;

      for (const keyX of keysX) {
        if (lookupByOutputKey[keyX] !== undefined) continue;
        if (y[keyX] === undefined) return false;
        const keyXYEq = extraProps.equals(x[keyX], y[keyX]);
        if (!keyXYEq) return false;
      } // Note: it is not necessary to check for extra properties on y,
      // because we already know that they have the same number of keys.
      // if y was not missing a property of x in the undefined check above,
      // then the keys must be the same (and have been checked above)


      return knownEqual;
    });
  },
  record: /*#__PURE__*/(0, _function.flow)(_function.SK, RR.getEq),
  intersection: (x, y) => Eq.fromEquals((a, b) => x.equals(a, b) && y.equals(a, b))
};
exports.StructEq = StructEq;
//# sourceMappingURL=eq.js.map