"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructGuard = void 0;

var B = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/boolean.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Pred = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Predicate.js"));

var RR = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyRecord.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const isObject = u => typeof u === 'object' && u !== null && !Array.isArray(u);

const StructGuard = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties);
    return {
      is: (0, _function.pipe)(isObject, Pred.and(u => {
        // -- if extra props are not allowed, return a failure on keys not specified in properties
        if (extraProps === 'error') {
          for (const key in u) {
            if (lookupByOutputKey[key] === undefined) return false;
          }
        } // -- if extra props are stripped then their presence is not a failure


        const knownMatch = (0, _function.pipe)(lookupByOutputKey, RR.foldMapWithIndex(Str.Ord)(B.MonoidAll)((key, members) => {
          const inputAtKey = u[key];

          for (const {
            member
          } of members) {
            if (member.is(inputAtKey)) return true;
          }

          return false;
        }));

        if (typeof extraProps === 'string' || knownMatch === false) {
          return knownMatch;
        }

        const restMatch = (0, _function.pipe)(u, RR.foldMapWithIndex(Str.Ord)(B.MonoidAll)((key, value) => {
          if (lookupByOutputKey[key] !== undefined) return true;
          return extraProps.is(value);
        }));
        return restMatch && knownMatch;
      }), a => a)
    };
  },
  record: (sk, so) => ({
    is: (0, _function.pipe)(isObject, Pred.and(RR.foldMapWithIndex(Str.Ord)(B.MonoidAll)((key, value) => sk.is(key) && so.is(value))), _ => _)
  }),
  intersection: (x, y) => ({
    is: (0, _function.pipe)(x.is, Pred.and(y.is), _ => _)
  })
};
exports.StructGuard = StructGuard;
//# sourceMappingURL=guard.js.map