"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructJsonSchema = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Mn = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Monoid.js"));

var RA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyArray.js"));

var RR = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyRecord.js"));

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var JS = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/json-schema"));

var _struct = /*#__PURE__*/require("schemata-ts/internal/struct");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const StructJsonSchema = {
  struct: (properties, extraProps) => {
    const [requiredKeys, jsonSchema] = (0, _function.pipe)(properties, RR.foldMapWithIndex(Str.Ord)(Mn.tuple(RA.getMonoid(), RR.getUnionMonoid(Sg.first())))((key, {
      schemable
    }) => (0, _function.tuple)((0, _struct.hasImplicitOptional)(schemable) ? [] : [key], {
      [key]: schemable
    })));
    return new JS.JsonStruct(jsonSchema, requiredKeys, extraProps === 'error' ? false : extraProps === 'strip' ? undefined : extraProps);
  },
  record: (keys, so) => JS.make(new JS.JsonStruct({}, [], so, keys)),
  intersection: (x, y) => JS.make(new JS.JsonIntersection([x, y]))
};
exports.StructJsonSchema = StructJsonSchema;
//# sourceMappingURL=json-schema.js.map