"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructMergeSemigroup = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RR = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyRecord.js"));

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var MSg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/merge-semigroup"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const StructMergeSemigroup = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties);
    return MSg.makeMergeSemigroup((concrete = 'last') => (x, y) => {
      const knownMerged = (0, _function.pipe)(lookupByOutputKey, RR.mapWithIndex((key, msgs) => {
        const x_ = x[key];
        const y_ = y[key];

        for (const {
          member,
          guard
        } of msgs) {
          if (guard.is(x_) && guard.is(y_)) {
            return member.semigroup(concrete).concat(x_, y_);
          }
        }

        return concrete === 'first' || concrete !== 'last' && concrete.fallback === 'first' ? Sg.first().concat(x_, y_) : Sg.last().concat(x_, y_);
      }), _ => _);
      if (typeof extraProps === 'string') return knownMerged;
      const structMonoid = RR.getUnionMonoid(extraProps.semigroup(concrete));
      return structMonoid.concat(structMonoid.concat(x, y), knownMerged);
    });
  },
  record: (_, codomain) => MSg.constSemigroup(concrete => RR.getUnionMonoid(codomain.semigroup(concrete))),
  intersection: (o1, o2) => MSg.makeMergeSemigroup(concrete => {
    const o1Sg = o1.semigroup(concrete);
    const o2Sg = o2.semigroup(concrete);
    return (x, y) => (0, _utils.safeIntersect)(o1Sg.concat(x, y), o2Sg.concat(x, y));
  })
};
exports.StructMergeSemigroup = StructMergeSemigroup;
//# sourceMappingURL=merge-semigroup.js.map