"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructTranscoderPar = void 0;

var Ap = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Apply.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var O = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Option.js"));

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var TE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/TaskEither.js"));

var _struct = /*#__PURE__*/require("schemata-ts/internal/struct");

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

var TCP = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder-par"));

var _util = /*#__PURE__*/require("schemata-ts/internal/util");

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

var TCE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/TranscodeError"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const apSecond = /*#__PURE__*/Ap.apSecond(TCP.applicativeValidationPar);
const validateObject = /*#__PURE__*/(0, _utils.getValidateObject)(TE.MonadThrow);
const StructTranscoderPar = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip', // istanbul ignore next
  wholeName = 'object') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties);
    return {
      decode: u => {
        // --- typeof returns 'object' for null and arrays
        if (u === null || typeof u !== 'object' || Array.isArray(u)) {
          return TCP.failure(TC.transcodeErrors(TC.typeMismatch(wholeName, u)));
        } // --- decode all known properties of an object's own non-inherited properties


        const outKnown = (0, _function.pipe)(properties, (0, _util.witherRemapPar)(TCE.Semigroup)((k, prop) => {
          const inputKey = k;
          const {
            schemable,
            semigroup
          } = prop;
          const inputVal = u[inputKey];
          const outputKey = (0, _function.pipe)((0, _struct.getKeyRemap)(schemable), O.getOrElse(() => inputKey));
          return (0, _function.pipe)(schemable.decode(inputVal), TE.bimap(keyErrors => TC.transcodeErrors(TC.errorAtKey(inputKey, keyErrors)), result => O.some((0, _function.tuple)(result, outputKey, semigroup))));
        }));

        if (typeof extraProps !== 'string') {
          return (0, _function.pipe)(TE.Do, TE.apS('known', outKnown), TCP.apS('rest', (0, _function.pipe)(u, (0, _util.witherRemapPar)(TCE.Semigroup)((key, value) => {
            if (properties[key] === undefined) {
              return (0, _function.pipe)(extraProps.decode(value), TE.bimap(errs => TC.transcodeErrors(TC.errorAtKey(key, errs)), _ => O.some((0, _function.tuple)(_, key, Sg.last()))));
            }

            return TE.right(O.zero());
          }))), TE.map(({
            known,
            rest
          }) => (0, _utils.safeIntersect)(known, rest)));
        }

        if (extraProps === 'strip') return outKnown; // -- if extra props are not allowed, return a failure on keys not specified in properties

        return (0, _function.pipe)(u, (0, _util.witherRemapPar)(TCE.Semigroup)((key, value) => {
          if (properties[key] === undefined) {
            return TCP.failure(TC.transcodeErrors(TC.errorAtKey(key, TC.transcodeErrors(TC.unexpectedValue(value)))));
          }

          return TE.right(O.none);
        }), apSecond(outKnown));
      },
      encode: output => {
        return (0, _function.pipe)(output, (0, _util.witherRemapPar)(TCE.Semigroup)((key, outputAtKey) => {
          const unionMembers = lookupByOutputKey[key]; // -- Param is extra (and additional properties are stripped)

          if (unionMembers === undefined || !Array.isArray(unionMembers)) {
            if (typeof extraProps !== 'string') {
              return (0, _function.pipe)(extraProps.encode(outputAtKey), TE.map(result => O.some((0, _function.tuple)(result, key, Sg.last()))));
            }

            return TE.right(O.zero());
          }

          for (const {
            member,
            guard,
            inputKey,
            semigroup
          } of unionMembers) {
            if (guard.is(outputAtKey)) {
              return (0, _function.pipe)(member.encode(outputAtKey), TE.map(result => O.some((0, _function.tuple)(result, inputKey, semigroup))));
            }
          }

          return TCP.failure(TC.transcodeErrors(TC.errorAtKey(key, TC.transcodeErrors(...(unionMembers.length === 1 ? RNEA.of(TC.typeMismatch(RNEA.head(unionMembers).name, outputAtKey)) : (0, _function.pipe)(unionMembers, RNEA.mapWithIndex((i, {
            name
          }) => TC.errorAtUnionMember(i, TC.transcodeErrors(TC.typeMismatch(name, outputAtKey))))))))));
        }), _ => _);
      }
    };
  },
  record: (key, codomain, expectedName, semigroup) => ({
    decode: (0, _function.flow)(validateObject(expectedName), TE.chain((0, _util.witherRemapPar)(TCE.Semigroup)((k, u) => (0, _function.pipe)(Ap.sequenceT(TCP.applicativeValidationPar)(codomain.decode(u), key.decode(k), TE.right(semigroup)), TE.bimap(err => new TCE.TranscodeErrors([new TCE.ErrorAtKey(k, err)]), O.some), _ => _))), _ => _),
    encode: (0, _function.flow)((0, _util.witherRemapPar)(TCE.Semigroup)((k, u) => (0, _function.pipe)(Ap.sequenceT(TCP.applicativeValidationPar)(codomain.encode(u), key.encode(k), TE.right(semigroup)), TE.map(O.some), _ => _)), _ => _)
  }),
  intersection: (x, y) => ({
    decode: (0, _function.flow)(validateObject('object'), TE.chain(u => (0, _function.pipe)(Ap.sequenceT(TCP.applicativeValidationPar)(x.decode(u), y.decode(u)), TE.map(([x, y]) => (0, _utils.safeIntersect)(x, y))))),
    encode: u => (0, _function.pipe)(Ap.sequenceT(TCP.applicativeValidationPar)(x.encode(u), y.encode(u)), TE.map(([x, y]) => (0, _utils.safeIntersect)(x, y)))
  })
};
exports.StructTranscoderPar = StructTranscoderPar;
//# sourceMappingURL=transcoder-par.js.map