"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StructTranscoder = void 0;

var Ap = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Apply.js"));

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var O = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Option.js"));

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var _struct = /*#__PURE__*/require("schemata-ts/internal/struct");

var TC = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/internal/transcoder"));

var _util = /*#__PURE__*/require("schemata-ts/internal/util");

var _utils = /*#__PURE__*/require("schemata-ts/schemables/struct/utils");

var TCE = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/TranscodeError"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const validateObject = /*#__PURE__*/(0, _utils.getValidateObject)(E.MonadThrow);
const StructTranscoder = {
  struct: (properties, // istanbul ignore next
  extraProps = 'strip', // istanbul ignore next
  wholeName = 'object') => {
    const lookupByOutputKey = (0, _utils.remapPropertyKeys)(properties);
    return {
      decode: u => (0, _function.pipe)(validateObject(wholeName)(u), E.chain(u => {
        // --- decode all known properties of an object's own non-inherited properties
        const outKnown = (0, _function.pipe)(properties, (0, _util.witherRemap)(TCE.Semigroup)((k, prop) => {
          const inputKey = k;
          const {
            schemable,
            semigroup
          } = prop;
          const inputVal = u[inputKey];
          const outputKey = (0, _function.pipe)((0, _struct.getKeyRemap)(schemable), O.getOrElse(() => inputKey));
          return (0, _function.pipe)(schemable.decode(inputVal), E.bimap(keyErrors => TC.transcodeErrors(TC.errorAtKey(inputKey, keyErrors)), result => O.some([result, outputKey, semigroup])));
        }));

        if (typeof extraProps !== 'string') {
          return (0, _function.pipe)(E.Do, E.apS('known', outKnown), TC.apS('rest', (0, _function.pipe)(u, (0, _util.witherRemap)(TCE.Semigroup)((key, value) => {
            if (properties[key] === undefined) {
              return (0, _function.pipe)(extraProps.decode(value), E.bimap(errs => TC.transcodeErrors(TC.errorAtKey(key, errs)), _ => O.some((0, _function.tuple)(_, key, Sg.last()))));
            }

            return E.right(O.zero());
          }))), E.map(({
            known,
            rest
          }) => (0, _utils.safeIntersect)(known, rest)));
        }

        if (extraProps === 'strip') return outKnown; // -- if extra props are not allowed, return a failure on keys not specified in properties

        return (0, _function.pipe)(u, (0, _util.witherRemap)(TCE.Semigroup)((key, value) => {
          if (properties[key] === undefined) {
            return TC.failure(TC.transcodeErrors(TC.errorAtKey(key, TC.transcodeErrors(TC.unexpectedValue(value)))));
          }

          return E.right(O.zero());
        }), TC.apSecond(outKnown));
      })),
      encode: output => {
        return (0, _function.pipe)(output, (0, _util.witherRemap)(TCE.Semigroup)((key, outputAtKey) => {
          const unionMembers = lookupByOutputKey[key]; // -- Param is extra (and additional properties are stripped)

          if (unionMembers === undefined || !Array.isArray(unionMembers)) {
            if (typeof extraProps !== 'string') {
              return (0, _function.pipe)(extraProps.encode(outputAtKey), E.map(result => O.some((0, _function.tuple)(result, key, Sg.last()))));
            }

            return E.right(O.zero());
          }

          for (const {
            member,
            guard,
            inputKey,
            semigroup
          } of unionMembers) {
            if (guard.is(outputAtKey)) {
              return (0, _function.pipe)(member.encode(outputAtKey), E.map(result => O.some((0, _function.tuple)(result, inputKey, semigroup))));
            }
          }

          return TC.failure(TC.transcodeErrors(TC.errorAtKey(key, TC.transcodeErrors(...(unionMembers.length === 1 ? RNEA.of(TC.typeMismatch(RNEA.head(unionMembers).name, outputAtKey)) : (0, _function.pipe)(unionMembers, RNEA.mapWithIndex((i, {
            name
          }) => TC.errorAtUnionMember(i, TC.transcodeErrors(TC.typeMismatch(name, outputAtKey))))))))));
        }), _ => _);
      }
    };
  },
  record: (key, codomain, expectedName, semigroup) => ({
    decode: (0, _function.flow)(validateObject(expectedName), E.chain((0, _util.witherRemap)(TCE.Semigroup)((k, u) => (0, _function.pipe)(Ap.sequenceT(TC.applicativeValidation)(codomain.decode(u), key.decode(k), E.right(semigroup)), E.bimap(errs => new TCE.TranscodeErrors([new TCE.ErrorAtKey(k, errs)]), O.some), _ => _))), _ => _),
    encode: (0, _function.flow)((0, _util.witherRemap)(TCE.Semigroup)((k, u) => (0, _function.pipe)(Ap.sequenceT(TC.applicativeValidation)(codomain.encode(u), key.encode(k), E.right(semigroup)), E.map(O.some), _ => _)), _ => _)
  }),
  intersection: (x, y) => ({
    decode: (0, _function.flow)(validateObject('object'), E.chain(u => (0, _function.pipe)(Ap.sequenceT(TC.applicativeValidation)(x.decode(u), y.decode(u)), E.map(([x, y]) => (0, _utils.safeIntersect)(x, y))))),
    encode: u => (0, _function.pipe)(Ap.sequenceT(TC.applicativeValidation)(x.encode(u), y.encode(u)), E.map(([x, y]) => (0, _utils.safeIntersect)(x, y)))
  })
};
exports.StructTranscoder = StructTranscoder;
//# sourceMappingURL=transcoder.js.map