import { type Kind2, type URIS2 } from 'fp-ts/HKT';
import { type MonadThrow2 } from 'fp-ts/MonadThrow';
import * as RNEA from 'fp-ts/ReadonlyNonEmptyArray';
import { type Semigroup } from 'fp-ts/Semigroup';
import { type SchemableLambda } from 'schemata-ts/internal/schemable';
import { type GuardedPrecedentedUnionMember } from 'schemata-ts/schemables/guarded-union/definition';
import { type StructProp } from 'schemata-ts/schemables/struct/type-utils';
import { type TranscodeErrors } from 'schemata-ts/TranscodeError';
export type UnionItem<S extends SchemableLambda> = GuardedPrecedentedUnionMember<S> & {
    readonly inputKey: string;
    readonly semigroup: Semigroup<any>;
};
/**
 * Collapses a struct definition into a record with remapped keys whose values are union
 * members of every output key collision for that key.
 */
export declare const remapPropertyKeys: <S extends SchemableLambda>(properties: Record<string, StructProp<S>>, mapInformation?: (information: number) => number) => Record<string, RNEA.ReadonlyNonEmptyArray<UnionItem<S>>>;
export declare const safeIntersect: <A, B>(a: A, b: B) => A & B;
export declare const getValidateObject: <M extends URIS2>(M: MonadThrow2<M>) => (name: string) => (u: unknown) => Kind2<M, TranscodeErrors, Record<string | number | symbol, unknown>>;
//# sourceMappingURL=utils.d.ts.map