import { type Branded } from 'schemata-ts/brand';
import { type Schema } from 'schemata-ts/Schema';
interface Base64Brand {
    readonly Base64: unique symbol;
}
/**
 * Represents a Base64-encoded string.
 *
 * For a URL-safe version, @see Base64UrlSafe module
 *
 * @since 1.0.0
 * @category Model
 */
export type Base64 = Branded<string, Base64Brand>;
/**
 * Represents a Base64-encoded string.
 *
 * For a URL-safe version, @see Base64UrlSafe module
 *
 * @since 1.0.0
 * @category String
 */
export declare const Base64: Schema<Base64>;
export {};
//# sourceMappingURL=Base64.d.ts.map