import { type Branded } from 'schemata-ts/brand';
import { type Schema } from 'schemata-ts/Schema';
interface Base64UrlBrand {
    readonly Base64Url: unique symbol;
}
/**
 * Represents a URL-safe, Base64 encoded string.
 *
 * For a non-URL-safe alternative, @see Base64
 *
 * @since 1.0.0
 * @category Model
 */
export type Base64Url = Branded<string, Base64UrlBrand>;
/**
 * Represents a URL-safe, Base64 encoded string.
 *
 * For a non-URL-safe alternative, @see Base64
 *
 * @since 1.0.0
 * @category String
 */
export declare const Base64Url: Schema<Base64Url>;
export {};
//# sourceMappingURL=Base64Url.d.ts.map