"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bigIntString = exports.BigIntFromString = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var O = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Option.js"));

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var k = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("kuvio"));

var _Brand = /*#__PURE__*/require("schemata-ts/schemata/Brand");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _Pattern = /*#__PURE__*/require("schemata-ts/schemata/Pattern");

var _Refine = /*#__PURE__*/require("schemata-ts/schemata/Refine");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * @since 1.0.0
 * @category Pattern
 */
const binaryBigIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0b'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.characterClass(false, ['0', '1']), /*#__PURE__*/k.atLeastOne())));
/**
 * @since 1.0.0
 * @category Pattern
 */

const octalBigIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0o'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.characterClass(false, ['0', '7']), /*#__PURE__*/k.atLeastOne())));
/**
 * @since 1.0.0
 * @category Pattern
 */

const decimalBigIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.char('-'), k.maybe, /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)(k.digit, /*#__PURE__*/k.atLeastOne())));
/**
 * @since 1.0.0
 * @category Pattern
 */

const hexBigIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0x'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)(k.hexDigit, /*#__PURE__*/k.atLeastOne())));
/**
 * @since 1.0.0
 * @category Pattern
 */

const bigIntString = /*#__PURE__*/k.oneOf(binaryBigIntString, octalBigIntString, decimalBigIntString, hexBigIntString);
/**
 * Represents bigints converted from strings
 *
 * @since 1.0.0
 * @category Conversion
 */

exports.bigIntString = bigIntString;
const BigIntFromString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Pattern.Pattern)(bigIntString, 'BigIntString'), /*#__PURE__*/(0, _Refine.Refine)(s => (0, _function.pipe)(s, O.fromPredicate((0, _function.flow)(Str.trim, s => s.length > 0)), O.chain(O.tryCatchK(s => BigInt(s))), O.isSome), 'bigint'), /*#__PURE__*/(0, _Brand.Brand)(), /*#__PURE__*/(0, _Imap.Imap)({
  is: u => typeof u === 'bigint'
}, b => BigInt(b), n => n.toString()));
exports.BigIntFromString = BigIntFromString;
//# sourceMappingURL=BigIntFromString.js.map