"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BooleanFromNumber = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _Boolean = /*#__PURE__*/require("schemata-ts/schemata/Boolean");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

/** @since 1.0.0 */

/**
 * A boolean value whose encoded representation is a number, where 0 is false and 1 is true.
 *
 * Strictly speaking, this will _decode_ any number (0 becomes false, and non-zero becomes
 * true), but will only _encode_ 0 and 1.
 *
 * @since 1.0.0
 * @category Conversion
 */
const BooleanFromNumber = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Float.Float)(), /*#__PURE__*/(0, _Imap.Imap)( /*#__PURE__*/(0, _guardSchemable.deriveGuard)(_Boolean.Boolean), n => n !== 0, b => b ? 1 : 0, 'boolean'));
exports.BooleanFromNumber = BooleanFromNumber;
//# sourceMappingURL=BooleanFromNumber.js.map