"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.booleanFromStringPattern = exports.BooleanFromString = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var k = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("kuvio"));

var _Guard = /*#__PURE__*/require("schemata-ts/Guard");

var _Boolean = /*#__PURE__*/require("schemata-ts/schemata/Boolean");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _Pattern = /*#__PURE__*/require("schemata-ts/schemata/Pattern");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * @since 1.0.0
 * @category Pattern
 */
const booleanFromStringPattern = /*#__PURE__*/k.oneOf( /*#__PURE__*/k.exactString('true'), /*#__PURE__*/k.exactString('false'));
/**
 * A boolean value whose encoded representation is either "true" or "false".
 *
 * @since 1.0.0
 * @category Conversion
 */

exports.booleanFromStringPattern = booleanFromStringPattern;
const BooleanFromString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Pattern.Pattern)(booleanFromStringPattern, ["'true' | 'false'", 'boolean']), /*#__PURE__*/(0, _Imap.Imap)( /*#__PURE__*/(0, _Guard.deriveGuard)(_Boolean.Boolean), s => s === 'true', b => b ? 'true' : 'false'));
exports.BooleanFromString = BooleanFromString;
//# sourceMappingURL=BooleanFromString.js.map