/** @since 2.0.0 */
import { type MergeStrategy } from 'schemata-ts/internal/merge-semigroup';
import { type Schema } from 'schemata-ts/Schema';
import { type CamelCase } from 'schemata-ts/schemata/CamelCaseString';
/**
 * A record combinator which converts the keys of a record to camel case.
 *
 * @since 2.0.0
 * @category Combinators
 */
export declare const CamelCaseRecord: <I, O>(codomain: Schema<I, O>, mergeStrategy?: MergeStrategy) => Schema<Readonly<Record<CamelCase, I>>, Readonly<Record<CamelCase, O>>>;
//# sourceMappingURL=CamelCaseRecord.d.ts.map