import { type Branded } from 'schemata-ts/brand';
import { type Schema } from 'schemata-ts/Schema';
import { type StringParams } from 'schemata-ts/schemables/primitives/definition';
interface CamelCaseStringBrand {
    readonly Base64: unique symbol;
}
/**
 * @since 2.0.0
 * @category Model
 */
export type CamelCase = Branded<string, CamelCaseStringBrand>;
/**
 * A schema that converts any string to camel-case
 *
 * @since 2.0.0
 * @category String
 */
export declare const CamelCaseString: (params?: StringParams) => Schema<CamelCase>;
export {};
//# sourceMappingURL=CamelCaseString.d.ts.map