"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CamelCaseString = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _camelcase = /*#__PURE__*/require("schemata-ts/internal/camelcase");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _String = /*#__PURE__*/require("schemata-ts/schemata/String");

/** @since 2.0.0 */

/**
 * A schema that converts any string to camel-case
 *
 * @since 2.0.0
 * @category String
 */
const CamelCaseString = params => {
  const string = (0, _String.String)(params);
  return (0, _function.pipe)(string, (0, _Imap.Imap)((0, _guardSchemable.deriveGuard)(string), _camelcase.camelCase, _function.identity));
};

exports.CamelCaseString = CamelCaseString;
//# sourceMappingURL=CamelCaseString.js.map