"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckDigit = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

/** @since 1.0.0 */

/**
 * Verifies a character of a string against a check digit algorithm, useful for ISBNs,
 * credit cards, and others
 *
 * @since 1.0.0
 * @category Combinators
 */
const CheckDigit = (algorithm, location) => schema => (0, _schema.make)(s => s.checkDigit(algorithm, location)(schema.runSchema(s)));

exports.CheckDigit = CheckDigit;
//# sourceMappingURL=CheckDigit.js.map