import { type Branded } from 'schemata-ts/brand';
import { type Schema } from 'schemata-ts/Schema';
import { type CheckDigitVerified } from 'schemata-ts/schemables/check-digit/definition';
interface CreditCardBrand {
    readonly CreditCard: unique symbol;
}
/**
 * @since 1.0.0
 * @category Model
 */
export type CreditCard = Branded<CheckDigitVerified, CreditCardBrand>;
/**
 * Represents a credit card number; currently this should accept Visa, Mastercard,
 * American Express, Diners Club, Discover, JCB, Rupay, and UnionPay.
 *
 * @since 1.0.0
 * @category String
 */
export declare const CreditCard: Schema<CreditCard>;
export {};
//# sourceMappingURL=CreditCard.d.ts.map