"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CreditCard = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var k = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("kuvio"));

var _algorithms = /*#__PURE__*/require("schemata-ts/internal/algorithms");

var _Brand = /*#__PURE__*/require("schemata-ts/schemata/Brand");

var _CheckDigit = /*#__PURE__*/require("schemata-ts/schemata/CheckDigit");

var _Pattern = /*#__PURE__*/require("schemata-ts/schemata/Pattern");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * Represents a credit card number; currently this should accept Visa, Mastercard,
 * American Express, Diners Club, Discover, JCB, Rupay, and UnionPay.
 *
 * @since 1.0.0
 * @category String
 */
const CreditCard = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Pattern.Pattern)(k.patterns.creditCard, 'CreditCard'), /*#__PURE__*/(0, _CheckDigit.CheckDigit)(ccn => (0, _algorithms.luhn)(ccn.substring(0, ccn.length - 1)).toString(10), ccn => ccn.length - 1), /*#__PURE__*/(0, _Brand.Brand)());
exports.CreditCard = CreditCard;
//# sourceMappingURL=CreditCard.js.map