"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateFromInt = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _Date = /*#__PURE__*/require("schemata-ts/schemata/Date");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _Int = /*#__PURE__*/require("schemata-ts/schemata/Int");

/** @since 1.0.0 */

/**
 * Represents Date objects derived from time in milliseconds.
 *
 * @since 1.0.0
 * @category Conversion
 */
const DateFromInt = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Int.Int)({
  min: -8_640_000_000_000_000,
  max: 8_640_000_000_000_000
}), /*#__PURE__*/(0, _Imap.Imap)( /*#__PURE__*/(0, _guardSchemable.deriveGuard)( /*#__PURE__*/(0, _Date.Date)()), n => new Date(n), d => d.getTime()));
exports.DateFromInt = DateFromInt;
//# sourceMappingURL=DateFromInt.js.map