import { type Float } from 'schemata-ts/float';
import { type Schema } from 'schemata-ts/Schema';
import { type SafeDate } from 'schemata-ts/schemables/date/definition';
/** @since 2.0.0 */
export type MinUnixTime = -8_640_000_000_000;
/** @since 2.0.0 */
export declare const minUnixTime: MinUnixTime;
/** @since 2.0.0 */
export type MaxUnixTime = 8_640_000_000_000;
/** @since 2.0.0 */
export declare const maxUnixTime: MaxUnixTime;
/**
 * Represents Date objects derived from unix time.
 *
 * @since 1.0.0
 * @category Conversion
 */
export declare const DateFromUnixTime: Schema<Float<MinUnixTime, MaxUnixTime>, SafeDate>;
//# sourceMappingURL=DateFromUnixTime.d.ts.map