"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.minUnixTime = exports.maxUnixTime = exports.DateFromUnixTime = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _Date = /*#__PURE__*/require("schemata-ts/schemata/Date");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

/** @since 1.0.0 */

/** @since 2.0.0 */
const minUnixTime = -8_640_000_000_000;
/** @since 2.0.0 */

exports.minUnixTime = minUnixTime;
const maxUnixTime = 8_640_000_000_000;
exports.maxUnixTime = maxUnixTime;
const UnixTimeFloat = /*#__PURE__*/(0, _Float.Float)({
  min: minUnixTime,
  max: maxUnixTime
});
const DateSchema = /*#__PURE__*/(0, _Date.Date)();
/**
 * Represents Date objects derived from unix time.
 *
 * @since 1.0.0
 * @category Conversion
 */

const DateFromUnixTime = /*#__PURE__*/(0, _function.pipe)(UnixTimeFloat, /*#__PURE__*/(0, _Imap.Imap)( /*#__PURE__*/(0, _guardSchemable.deriveGuard)(DateSchema), n => new Date(n * 1000), d => d.getTime() / 1000, /*#__PURE__*/(0, _typeStringSchemable.deriveTypeString)(DateSchema)[1]));
exports.DateFromUnixTime = DateFromUnixTime;
//# sourceMappingURL=DateFromUnixTime.js.map