/** @since 1.0.0 */
import * as k from 'kuvio';
import { type Branded } from 'schemata-ts/brand';
import { type Schema } from 'schemata-ts/Schema';
interface EthereumAddressBrand {
    readonly EthereumAddress: unique symbol;
}
/**
 * Represents strings which are valid Ethereum addresses.
 *
 * @since 1.0.0
 * @category Model
 */
export type EthereumAddress = Branded<string, EthereumAddressBrand>;
/**
 * @since 1.0.0
 * @category Pattern
 */
export declare const ethereumAddress: k.Pattern;
/**
 * Represents strings which are valid Ethereum addresses.
 *
 * @since 1.0.0
 * @category String
 */
export declare const EthereumAddress: Schema<EthereumAddress>;
export {};
//# sourceMappingURL=EthereumAddress.d.ts.map