"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Imap = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

/**
 * A Schema that maps the output type of another Schema. Guard is not invariant, and
 * `Imap` requires an explicit guard for the output type.
 *
 * @since 1.0.0
 * @category Mapping
 */
const Imap = (targetGuard, f, g, newName) => target => (0, _schema.make)(S => S.imap(targetGuard, newName)(f, g)(target.runSchema(S)));

exports.Imap = Imap;
//# sourceMappingURL=Imap.js.map