"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.intFromString = exports.IntFromString = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var k = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("kuvio"));

var _guard = /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/guard");

var _typeString = /*#__PURE__*/require("schemata-ts/schemables/primitives/instances/type-string");

var _Brand = /*#__PURE__*/require("schemata-ts/schemata/Brand");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _Pattern = /*#__PURE__*/require("schemata-ts/schemata/Pattern");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * @since 1.0.0
 * @category Pattern
 */
const binaryIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0b'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.characterClass(false, ['0', '1']), /*#__PURE__*/k.between(1, 53))));
/**
 * @since 1.0.0
 * @category Pattern
 */

const octalIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0o'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.characterClass(false, ['0', '7']), /*#__PURE__*/k.between(1, 18))));
/**
 * @since 1.0.0
 * @category Pattern
 */

const decimalIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.char('-'), k.maybe, /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)(k.digit, /*#__PURE__*/k.between(1, 16))));
/**
 * @since 1.0.0
 * @category Pattern
 */

const hexIntString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/k.exactString('0x'), /*#__PURE__*/k.andThen( /*#__PURE__*/(0, _function.pipe)(k.hexDigit, /*#__PURE__*/k.between(1, 14))));
/**
 * @since 1.0.0
 * @category Pattern
 */

const intFromString = /*#__PURE__*/k.oneOf(binaryIntString, octalIntString, decimalIntString, hexIntString);
/**
 * Integer branded newtype from string. Parameters: min, max are inclusive.
 *
 * Note: has an optional `encodeToBase` parameter that controls the output base of the
 * encoded string. Currently only decodes binary, octal, decimal, and hexadecimal input
 * bases. It decodes in any base, and encodes to supplied parameter defaulting to decimal.
 *
 * _Note_: Does not currently allow exponential notation (e.g. `0x123e4`).
 *
 * Represents string-integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z <= 2 ** 53 - 1 }
 * ```
 *
 * @deprecated Use `ParseInt` instead.
 * @since 1.0.0
 * @category Conversion
 */

exports.intFromString = intFromString;
const IntFromString = /*#__PURE__*/(0, _function.pipe)( /*#__PURE__*/(0, _Pattern.Pattern)(intFromString, ['IntString', /*#__PURE__*/_typeString.PrimitivesTypeString.int()[1]]), /*#__PURE__*/(0, _Brand.Brand)(), /*#__PURE__*/(0, _Imap.Imap)( /*#__PURE__*/_guard.PrimitivesGuard.int(), s => Number(s), n => n.toString()));
exports.IntFromString = IntFromString;
//# sourceMappingURL=IntFromString.js.map