"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Lazy = void 0;

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

/**
 * A lazy schema is a schema for mutual recursive types.
 *
 * **Note: deriving mutually recursive arbitraries is not currently supported**
 *
 * @since 1.0.0
 * @category Combinators
 */
const Lazy = (name, f) => (0, _schema.make)(_ => _.lazy(name, () => f().runSchema(_)));

exports.Lazy = Lazy;
//# sourceMappingURL=Lazy.js.map