"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MapFromEntries = void 0;

var _mergeSemigroupSchemable = /*#__PURE__*/require("schemata-ts/derivations/merge-semigroup-schemable");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var _typeString = /*#__PURE__*/require("schemata-ts/schemables/array/instances/type-string");

const {
  array,
  tuple
} = _typeString.ArrayTypeString;
/**
 * A Schema for converting an array of key/value pairs to a map
 *
 * @since 1.0.0
 * @category Combinators
 */

const MapFromEntries = (ordK, sK, sA, // istanbul ignore next
mergeStrategy = 'last') => {
  const tsA = (0, _typeStringSchemable.deriveTypeString)(sA);
  const arrayName = array({
    expectedName: tsA[0]
  })(tuple('', (0, _typeStringSchemable.deriveTypeString)(sK), tsA));
  const mergeSemigroup = (0, _mergeSemigroupSchemable.deriveMergeSemigroup)(sA).semigroup(mergeStrategy);
  return (0, _schema.make)(S => S.mapFromEntries(ordK, sK.runSchema(S), sA.runSchema(S), arrayName[0], mergeSemigroup));
};

exports.MapFromEntries = MapFromEntries;
//# sourceMappingURL=MapFromEntries.js.map