/** @since 1.0.0 */
import { type Integer, type MaxSafeInt } from 'schemata-ts/integer';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Natural branded newtype.
 *
 * Represents integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z >= 0, z <= 2 ** 53 - 1 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const Natural: Schema<Integer<0, MaxSafeInt>>;
//# sourceMappingURL=Natural.d.ts.map