/** @since 1.0.0 */
import { type Float, type MaxNegativeFloat, type MinNegativeFloat } from 'schemata-ts/float';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Negative floating point branded newtype.
 *
 * Represents negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f < 0, f >= -Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const NegativeFloat: Schema<Float<MaxNegativeFloat, MinNegativeFloat>>;
//# sourceMappingURL=NegativeFloat.d.ts.map