"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NegativeFloat = void 0;

var _float = /*#__PURE__*/require("schemata-ts/float");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

/** @since 1.0.0 */

/**
 * Negative floating point branded newtype.
 *
 * Represents negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f < 0, f >= -Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const NegativeFloat = /*#__PURE__*/(0, _Float.Float)({
  min: _float.maxNegativeFloat,
  max: _float.minNegativeFloat
});
exports.NegativeFloat = NegativeFloat;
//# sourceMappingURL=NegativeFloat.js.map