/** @since 1.0.0 */
import { type Integer, type MinSafeInt } from 'schemata-ts/integer';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Negative integer branded newtype.
 *
 * Represents negative integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z < 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const NegativeInt: Schema<Integer<MinSafeInt, -1>>;
//# sourceMappingURL=NegativeInt.d.ts.map