"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NegativeInt = void 0;

var _integer = /*#__PURE__*/require("schemata-ts/integer");

var _Int = /*#__PURE__*/require("schemata-ts/schemata/Int");

/** @since 1.0.0 */

/**
 * Negative integer branded newtype.
 *
 * Represents negative integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z < 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const NegativeInt = /*#__PURE__*/(0, _Int.Int)({
  min: _integer.minSafeInt,
  max: -1
});
exports.NegativeInt = NegativeInt;
//# sourceMappingURL=NegativeInt.js.map