/** @since 1.0.0 */
import { type Float, type MaxPositiveFloat } from 'schemata-ts/float';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Non-negative floating point branded newtype.
 *
 * Represents non-negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f >= 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const NonNegativeFloat: Schema<Float<0, MaxPositiveFloat>>;
//# sourceMappingURL=NonNegativeFloat.d.ts.map