"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NonNegativeFloat = void 0;

var _float = /*#__PURE__*/require("schemata-ts/float");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

/** @since 1.0.0 */

/**
 * Non-negative floating point branded newtype.
 *
 * Represents non-negative floating point numbers:
 *
 * ```math
 *  { f | f ∈ ℝ, f >= 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const NonNegativeFloat = /*#__PURE__*/(0, _Float.Float)({
  min: 0,
  max: _float.maxPositiveFloat
});
exports.NonNegativeFloat = NonNegativeFloat;
//# sourceMappingURL=NonNegativeFloat.js.map