/** @since 1.0.0 */
import { type Integer, type MinSafeInt } from 'schemata-ts/integer';
import { type Schema } from 'schemata-ts/Schema';
/**
 * NonPositive integer branded newtype.
 *
 * Represents integers which are negative or zero.
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z <= 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const NonPositiveInt: Schema<Integer<MinSafeInt, 0>>;
//# sourceMappingURL=NonPositiveInt.d.ts.map