"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NonPositiveInt = void 0;

var _integer = /*#__PURE__*/require("schemata-ts/integer");

var _Int = /*#__PURE__*/require("schemata-ts/schemata/Int");

/** @since 1.0.0 */

/**
 * NonPositive integer branded newtype.
 *
 * Represents integers which are negative or zero.
 *
 * ```math
 *  { z | z ∈ ℤ, z >= -2 ** 53 + 1, z <= 0 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const NonPositiveInt = /*#__PURE__*/(0, _Int.Int)({
  min: _integer.minSafeInt,
  max: 0
});
exports.NonPositiveInt = NonPositiveInt;
//# sourceMappingURL=NonPositiveInt.js.map