"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Option = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _Annotate = /*#__PURE__*/require("schemata-ts/schemata/Annotate");

var _Literal = /*#__PURE__*/require("schemata-ts/schemata/Literal");

var _Struct = /*#__PURE__*/require("schemata-ts/schemata/Struct");

var _Union = /*#__PURE__*/require("schemata-ts/schemata/Union");

/** @since 2.0.0 */

/**
 * A schema that represents the `Option` type from fp-ts.
 *
 * @since 2.0.0
 * @category Combinators
 */
const Option = inner => (0, _function.pipe)((0, _Union.Union)((0, _Struct.Struct)({
  _tag: (0, _Literal.Literal)('None')
}), (0, _Struct.Struct)({
  _tag: (0, _Literal.Literal)('Some'),
  value: inner
})), (0, _Annotate.Annotate)({
  typeString: (0, _function.pipe)((0, _typeStringSchemable.deriveTypeString)(inner), ([input, output]) => `Option<${input}, ${output}>`)
}));

exports.Option = Option;
//# sourceMappingURL=Option.js.map