"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionFromNullable = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var O = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Option.js"));

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _Guard = /*#__PURE__*/require("schemata-ts/Guard");

var _struct = /*#__PURE__*/require("schemata-ts/internal/struct");

var _Imap = /*#__PURE__*/require("schemata-ts/schemata/Imap");

var _Nullable = /*#__PURE__*/require("schemata-ts/schemata/Nullable");

var _Option2 = /*#__PURE__*/require("schemata-ts/schemata/Option");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * Represents an optional type which decodes from null and undefined and encodes to null
 *
 * @since 1.0.0
 * @category Conversion
 */
const OptionFromNullable = inner => {
  const guard = (0, _Guard.deriveGuard)((0, _Option2.Option)(inner));
  return (0, _struct.makeImplicitOptionalType)((0, _function.pipe)((0, _Nullable.Nullable)(inner), (0, _Imap.Imap)({
    is: u => guard.is(u) && (0, _function.pipe)(u, O.fold(() => true, a => a !== undefined && a !== null))
  }, O.fromNullable, O.toNullable, `Option<${(0, _typeStringSchemable.deriveTypeString)(inner)[1]}>`)));
};

exports.OptionFromNullable = OptionFromNullable;
//# sourceMappingURL=OptionFromNullable.js.map