import { type ImplicitOptional } from 'schemata-ts/internal/struct';
import { type Schema } from 'schemata-ts/Schema';
/**
 * A schema that widens a schema to include `undefined`. Also marks the input property of
 * a struct as optional.
 *
 * Optional property `fallbackInput` is used to provide a default value for transcoders
 * and json-schemas.
 *
 * @since 1.0.0
 * @category Combinators
 */
export declare const Optional: <I, O, Fallback extends I | undefined = undefined>(target: Schema<I, O>, fallbackInput?: Fallback | undefined) => Fallback extends undefined ? ImplicitOptional & Schema<I | undefined, O | undefined> : ImplicitOptional & Schema<I | undefined, O>;
//# sourceMappingURL=Optional.d.ts.map