"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Optional = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

/** @since 1.0.0 */

/**
 * A schema that widens a schema to include `undefined`. Also marks the input property of
 * a struct as optional.
 *
 * Optional property `fallbackInput` is used to provide a default value for transcoders
 * and json-schemas.
 *
 * @since 1.0.0
 * @category Combinators
 */
const Optional = (target, fallbackInput) => (0, _function.unsafeCoerce)((0, _schema.make)(_ => _.optional(target.runSchema(_), (0, _typeStringSchemable.deriveTypeString)(target)[0], {
  fallbackInput
})));

exports.Optional = Optional;
//# sourceMappingURL=Optional.js.map