"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParseBase64Json = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _util = /*#__PURE__*/require("schemata-ts/internal/util");

var _Annotate = /*#__PURE__*/require("schemata-ts/schemata/Annotate");

var _ParseEncodedJson = /*#__PURE__*/require("schemata-ts/schemata/ParseEncodedJson");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Parses a base64-encoded and (URIComponent) escaped JSON string.
 *
 * @since 2.0.0
 * @category Printer Parsers
 */
const ParseBase64Json = inner => (0, _function.pipe)(inner, (0, _ParseEncodedJson.ParseEncodedJsonString)(E.tryCatchK(input => decodeURIComponent((0, _util.base64Decode)(input)), _function.identity), E.tryCatchK(input => (0, _util.base64Encode)(encodeURIComponent(input)), _function.identity), {
  contentEncoding: 'base64',
  contentMediaType: 'application/json',
  nameOverride: 'Base64'
}), (0, _Annotate.Annotate)({
  typeString: ['Base64', (0, _typeStringSchemable.deriveTypeString)(inner)[1]]
}), _ => (0, _function.unsafeCoerce)(_));

exports.ParseBase64Json = ParseBase64Json;
//# sourceMappingURL=ParseBase64Json.js.map