/** @since 2.0.0 */
import { type Const } from 'fp-ts/Const';
import { type Either } from 'schemata-ts/internal/either';
import { type Schema } from 'schemata-ts/Schema';
import { type JsonString } from 'schemata-ts/schemables/parser/definition';
import { type ParserOptions } from 'schemata-ts/schemata/Parse';
/**
 * Applies a fallible string mapping function to a schema which parses a Json string.
 * Useful for things like conversion between character encodings.
 *
 * @since 2.0.0
 * @category Printer Parsers
 */
export declare const ParseEncodedJsonString: (decode: (encoded: string) => Either<unknown, string>, encode: (jsonString: string) => Either<unknown, string>, options?: ParserOptions & {
    readonly nameOverride?: string;
}) => <I, O>(inner: Schema<I, O>) => Schema<Const<JsonString, I>, O>;
//# sourceMappingURL=ParseEncodedJson.d.ts.map