"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParseEncodedJsonString = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var J = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Json.js"));

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _Parse = /*#__PURE__*/require("schemata-ts/schemata/Parse");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Applies a fallible string mapping function to a schema which parses a Json string.
 * Useful for things like conversion between character encodings.
 *
 * @since 2.0.0
 * @category Printer Parsers
 */
const ParseEncodedJsonString = (decode, encode, options = {}) => inner => (0, _function.pipe)(inner, (0, _Parse.Parse)(options.nameOverride ?? (0, _typeStringSchemable.deriveTypeString)(inner)[0], (0, _function.flow)(decode, E.chain(J.parse)), (0, _function.flow)(J.stringify, E.chain(encode)), options), _ => (0, _function.unsafeCoerce)(_));

exports.ParseEncodedJsonString = ParseEncodedJsonString;
//# sourceMappingURL=ParseEncodedJson.js.map