import { type Float as Floating, type MaxNegativeFloat, type MaxPositiveFloat } from 'schemata-ts/float';
import { type Schema } from 'schemata-ts/Schema';
import { type NumberParams } from 'schemata-ts/schemables/primitives/definition';
import { type FloatString } from 'schemata-ts/schemata/FloatFromString';
/**
 * Parses a string into an float. A slightly more performant variant of the now deprecated
 * `S.FloatFromString` with the additional ability to specify `min` / `max` bounds.
 *
 * @since 2.2.0
 * @category Printer Parsers
 */
export declare const ParseFloat: <Min extends number | undefined = undefined, Max extends number | undefined = undefined>(params?: NumberParams<Min, Max> | undefined) => Schema<FloatString<Min extends undefined ? -1.7976931348623157e+308 : Min, Max extends undefined ? 1.7976931348623157e+308 : Max>, Floating<Min extends undefined ? -1.7976931348623157e+308 : Min, Max extends undefined ? 1.7976931348623157e+308 : Max>>;
//# sourceMappingURL=ParseFloat.d.ts.map