"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParseFloat = void 0;

var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Either.js"));

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Str = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/string.js"));

var _utils = /*#__PURE__*/require("schemata-ts/schemables/primitives/utils");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

var _Parse = /*#__PURE__*/require("schemata-ts/schemata/Parse");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 2.2.0 */

/**
 * Parses a string into an float. A slightly more performant variant of the now deprecated
 * `S.FloatFromString` with the additional ability to specify `min` / `max` bounds.
 *
 * @since 2.2.0
 * @category Printer Parsers
 */
const ParseFloat = params => (0, _function.pipe)((0, _Float.Float)(params), (0, _Parse.Parse)(`FloatString${(0, _utils.getNumberBoundsInt)(params)}`, (0, _function.flow)(Str.trim, E.fromPredicate(s => s.length > 0, () => 'Expected a non-empty float string'), E.map(Number), E.filterOrElse((0, _utils.isFloat)(params), n => `Expected a floating point number between ${params?.min ?? Number.MIN_SAFE_INTEGER} and ${params?.max ?? Number.MAX_SAFE_INTEGER}, but got ${n}`)), (0, _function.flow)(String, _ => _, E.right)));

exports.ParseFloat = ParseFloat;
//# sourceMappingURL=ParseFloat.js.map