import { type Integer, type MaxSafeInt, type MinSafeInt } from 'schemata-ts/integer';
import { type Schema } from 'schemata-ts/Schema';
import { type NumberParams } from 'schemata-ts/schemables/primitives/definition';
import { type IntString } from 'schemata-ts/schemata/IntFromString';
/**
 * Parses a string into an integer. A slightly more performant variant of the now
 * deprecated `S.IntFromString` with the additional ability to specify `min` / `max` bounds.
 *
 * @since 2.2.0
 * @category Printer Parsers
 */
export declare const ParseInt: <Min extends number | undefined = undefined, Max extends number | undefined = undefined>(params?: NumberParams<Min, Max> | undefined) => Schema<IntString<Min extends undefined ? -9007199254740991 : Min, Max extends undefined ? 9007199254740991 : Max>, Integer<Min extends undefined ? -9007199254740991 : Min, Max extends undefined ? 9007199254740991 : Max>>;
//# sourceMappingURL=ParseInt.d.ts.map