/** @since 2.0.0 */
import { type Const } from 'fp-ts/Const';
import { type Schema } from 'schemata-ts/Schema';
import type * as _ from 'schemata-ts/schemables/parser/definition';
/**
 * A branded string representing a parsable JSON string
 *
 * @since 2.2.3
 * @category Model
 */
export type JsonString = _.JsonString;
/**
 * Parses a Json string using supplied schema
 *
 * @since 2.0.0
 * @category Printer Parsers
 */
export declare const ParseJsonString: <I, O>(inner: Schema<I, O>) => Schema<Const<JsonString, I>, O>;
//# sourceMappingURL=ParseJsonString.d.ts.map