"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Partial = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var Sg = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/Semigroup.js"));

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _informationSchemable = /*#__PURE__*/require("schemata-ts/derivations/information-schemable");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

var _typeString = /*#__PURE__*/require("schemata-ts/schemables/struct/instances/type-string");

var _Optional = /*#__PURE__*/require("schemata-ts/schemata/Optional");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * Used to construct a struct schema with enumerated keys where any number of known keys
 * are permitted.
 *
 * @deprecated Use `Struct({}).partial()` instead
 * @since 1.0.0
 * @category Combinators
 */
const Partial = (props, extraProps = 'strip') => (0, _function.unsafeCoerce)((0, _schema.make)(_ => {
  const struct = {};
  const structName = {};

  for (const key in props) {
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    const schema = (0, _Optional.Optional)(props[key]);
    const schemable = schema.runSchema(_);
    const guard = (0, _guardSchemable.deriveGuard)(schema);
    const information = (0, _informationSchemable.deriveInformation)(schema);
    const name = (0, _typeStringSchemable.deriveTypeString)(schema);
    struct[key] = {
      schemable,
      guard,
      information,
      semigroup: Sg.last(),
      name: name[0]
    };
    structName[key] = {
      schemable: name,
      guard,
      information,
      semigroup: Sg.last(),
      name: name[0]
    };
  }

  const wholeName = _typeString.StructTypeString.struct(structName, extraProps, '');

  return _.struct(struct, extraProps, wholeName[0]);
}));

exports.Partial = Partial;
//# sourceMappingURL=Partial.js.map