/** @since 1.0.0 */
import { type Float, type MaxPositiveFloat, type MinPositiveFloat } from 'schemata-ts/float';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Positive Float branded newtype.
 *
 * Represents floating point numbers:
 *
 * ```math
 *  { f | f ∈ R, f > 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const PositiveFloat: Schema<Float<MinPositiveFloat, MaxPositiveFloat>>;
//# sourceMappingURL=PositiveFloat.d.ts.map