"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PositiveFloat = void 0;

var _float = /*#__PURE__*/require("schemata-ts/float");

var _Float = /*#__PURE__*/require("schemata-ts/schemata/Float");

/** @since 1.0.0 */

/**
 * Positive Float branded newtype.
 *
 * Represents floating point numbers:
 *
 * ```math
 *  { f | f ∈ R, f > 0, f <= Number.MAX_VALUE }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const PositiveFloat = /*#__PURE__*/(0, _Float.Float)({
  min: _float.minPositiveFloat,
  max: _float.maxPositiveFloat
});
exports.PositiveFloat = PositiveFloat;
//# sourceMappingURL=PositiveFloat.js.map