/** @since 1.0.0 */
import { type Integer, type MaxSafeInt } from 'schemata-ts/integer';
import { type Schema } from 'schemata-ts/Schema';
/**
 * Positive integer branded newtype.
 *
 * Represents positive integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z > 0, z <= 2 ** 53 - 1 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
export declare const PositiveInt: Schema<Integer<1, MaxSafeInt>>;
//# sourceMappingURL=PositiveInt.d.ts.map