"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PositiveInt = void 0;

var _integer = /*#__PURE__*/require("schemata-ts/integer");

var _Int = /*#__PURE__*/require("schemata-ts/schemata/Int");

/** @since 1.0.0 */

/**
 * Positive integer branded newtype.
 *
 * Represents positive integers:
 *
 * ```math
 *  { z | z ∈ ℤ, z > 0, z <= 2 ** 53 - 1 }
 * ```
 *
 * @since 1.0.0
 * @category Number
 */
const PositiveInt = /*#__PURE__*/(0, _Int.Int)({
  min: 1,
  max: _integer.maxSafeInt
});
exports.PositiveInt = PositiveInt;
//# sourceMappingURL=PositiveInt.js.map