import { type MergeStrategy } from 'schemata-ts/internal/merge-semigroup';
import { type Schema } from 'schemata-ts/Schema';
/**
 * A Typescript Record type with string-keys and known values.
 *
 * Additional parameter `mergeStrategy` determines how to merge values for when keys are
 * remapped to the same string
 *
 * @since 1.0.0
 * @category Combinators
 */
export declare const Record: <K extends string, I, O>(keys: Schema<K, K>, codomain: Schema<I, O>, mergeStrategy?: 'first' | 'last' | MergeStrategy) => Schema<Readonly<Record<K, I>>, Readonly<Record<K, O>>>;
//# sourceMappingURL=Record.d.ts.map