/** @since 1.4.0 */
import { type OptionalInputProps, type OutputProps, type RequiredInputProps } from 'schemata-ts/internal/schema';
import { type Schema } from 'schemata-ts/Schema';
import { type Simplify } from 'type-fest';
/**
 * Same as `Struct` combinator, but disallows additional properties.
 *
 * @deprecated Use `Struct({}).strict()` instead
 * @since 2.0.0
 * @category Combinators
 */
export declare const Strict: <T extends Record<string, Schema<any, any>>>(props: T) => Schema<RequiredInputProps<T> & OptionalInputProps<T> extends infer T_1 ? { [KeyType_1 in keyof T_1]: (RequiredInputProps<T> & OptionalInputProps<T>)[KeyType_1]; } : never, { [KeyType_2 in keyof OutputProps<T>]: OutputProps<T>[KeyType_2]; }>;
//# sourceMappingURL=Strict.d.ts.map