import * as k from 'kuvio';
import * as Nt from 'schemata-ts/newtype';
import { type Schema } from 'schemata-ts/Schema';
/**
 * See: https://github.com/validatorjs/validator.js/blob/master/src/lib/isUUID.js
 *
 * @since 1.0.0
 * @category Pattern
 */
declare const uuidPattern: {
    1: k.TermSequence;
    2: k.TermSequence;
    3: k.TermSequence;
    4: k.TermSequence;
    5: k.TermSequence;
    any: k.TermSequence;
};
/**
 * @since 1.0.0
 * @category Model
 */
export type UUIDVersion = keyof typeof uuidPattern;
interface UUIDBrand<Version extends UUIDVersion> {
    readonly UUID: unique symbol;
    readonly UUIDVersion: Version;
}
/**
 * Represents strings that are UUIDs.
 *
 * @since 1.0.0
 * @category Model
 */
export interface UUID<Version extends UUIDVersion> extends Nt.Newtype<UUIDBrand<Version>, string> {
}
/**
 * A newtype iso for UUID
 *
 * @since 2.0.0
 */
export declare const isoUUID: <Version extends 2 | 1 | 3 | 4 | 5 | "any">() => Nt.NewtypeIso<UUID<Version>, string>;
/**
 * @since 1.0.0
 * @category String
 */
export declare const UUID: <Version extends 2 | 1 | 3 | 4 | 5 | "any">(version: Version) => Schema<string, UUID<Version>>;
export {};
//# sourceMappingURL=UUID.d.ts.map