"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isoUUID = exports.UUID = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var k = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("kuvio"));

var Nt = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("schemata-ts/newtype"));

var _Newtype = /*#__PURE__*/require("schemata-ts/schemata/Newtype");

var _Pattern = /*#__PURE__*/require("schemata-ts/schemata/Pattern");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 1.0.0 */

/**
 * See: https://github.com/validatorjs/validator.js/blob/master/src/lib/isUUID.js
 *
 * @since 1.0.0
 * @category Pattern
 */
const uuidPattern = {
  1: k.patterns.uuidV1,
  2: k.patterns.uuidV2,
  3: k.patterns.uuidV3,
  4: k.patterns.uuidV4,
  5: k.patterns.uuidV5,
  any: k.patterns.anyUUID
};
/**
 * A newtype iso for UUID
 *
 * @since 2.0.0
 */

const isoUUID = () => Nt.iso();
/**
 * @since 1.0.0
 * @category String
 */


exports.isoUUID = isoUUID;

const UUID = version => (0, _function.pipe)((0, _Pattern.Pattern)(uuidPattern[version], `UUID version ${version}`), (0, _Newtype.Newtype)(isoUUID(), `UUID version ${version}`));

exports.UUID = UUID;
//# sourceMappingURL=UUID.js.map