"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Union = void 0;

var _function = /*#__PURE__*/require("fp-ts/lib/function.js");

var RNEA = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("fp-ts/lib/ReadonlyNonEmptyArray.js"));

var _guardSchemable = /*#__PURE__*/require("schemata-ts/derivations/guard-schemable");

var _informationSchemable = /*#__PURE__*/require("schemata-ts/derivations/information-schemable");

var _typeStringSchemable = /*#__PURE__*/require("schemata-ts/derivations/type-string-schemable");

var _schema = /*#__PURE__*/require("schemata-ts/internal/schema");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @since 2.0.0 */

/**
 * Represents a union of different types. **Note: Union items ought to be mutually
 * exclusive**. To mitigate this, union items are first sorted from most complex to least
 * complex, and in the case of transcoder and guard the first match is kept.
 *
 * @since 2.0.0
 * @category Combinators
 */
const Union = (...members) => {
  return (0, _function.unsafeCoerce)((0, _schema.make)(s => (0, _function.pipe)(members, RNEA.map(schema => ({
    guard: (0, _guardSchemable.deriveGuard)(schema),
    precedence: (0, _informationSchemable.deriveInformation)(schema),
    name: (0, _typeStringSchemable.deriveTypeString)(schema)[0],
    member: schema.runSchema(s)
  })), guardedUnionMembers => s.guardedUnion(...guardedUnionMembers))));
};

exports.Union = Union;
//# sourceMappingURL=Union.js.map